    Changes in 1.4.19 (2025-12-17):

    * aven/survexport: Rework PLT export to use 2 character escapes for spaces
      and other characters which aren't valid in Compass station names.  We were
      using 3 character escapes, but that's unhelpful since Compass has a 12
      character station name limit.

    * cavern: The syntax of *instrument commands is now checked and a warning
      issued for problems.  The information in the command is still not yet used.

    * cavern: Improve description of --quiet option.  Reported by Wookey.

    * (Microsoft Windows version): The installer now always updates DLLs it
      installs rather than skipping DLLs which declare the same version number.
      This avoids problems when DLLs change in an upwardly but not downwardly
      compatible way but keep the same version number.  It also means downgrading
      now gives an install more like installing the older version from scratch
      would.  Our DLLs are all private and installed into our own install directory
      so there are no concerns with breaking other installed software.  Fixes #145.
      Reported by Footleg and Juan Corrin.

    * Fill in some missing Czech translations.

    * Update unofficial Inno Setup translations for the installer.

    * We now require at least FFmpeg >= 3.2 to build Survex.  This version was
      released in 2016 so should be easily available everywhere now.

    * (Microsoft Windows version): Drop workaround for wx-config --rescomp not
      working as this has now been fixed in the mingw package of wxWidgets.

    * Test suite:

      + Add test coverage for `*data normal` without `clino`.

    Changes in 1.4.18 (2025-11-04):

    * aven: Fix "Enter" in search control to zoom to results.  This was broken
      by the switch to wxSearchCtrl in 1.4.17.

    * aven: Fix "Find stations" search box width with wxWidgets >= 3.2.7.  Patch
      https://github.com/ojwb/survex/pull/15 from Thomas Holder.

    * aven: (Microsoft Windows version): Fix sizing of indicators (scalebar,
      compass, clino, colour key) on HiDPI monitors.  Fixes #144, reported by Juan
      Corrin.

    * aven/survexport: Set UTM zone and datum in exported Compass PLT.

    * cavern: Avoid duplicate errors/warnings with unconnected data.  Since 1.4.10,
      unconnected data is only a warning but that resulted in us running some
      checks on the survey tree twice, which could result in duplicate
      errors/warnings.

    * cavern: Fix parsing of hex digits in *set.  Hex digits a-f were incorrectly
      being handled as 0-5, so 0x0a was byte 0 not byte 10.

    * cavern: We now track the column as well as file:line where a station or
      survey name was used, so diagnostics which use these locations now report
      a column number too.

    * cavern: Show context if proj can't convert coords.  We only do this for .svx
      files currently as it is more complex for Compass and Walls data.

    * cavern: Fix reported column for error for `-` for Walls tape field.
      In this context, Walls requires 2 or more `-` to indicate an omitted field.

    * cavern: Compass MAK file parsing improvements:

      + Comments are now skipped.  Previously a commented-out MAK file command
        would still be interpreted by cavern, which was incorrect.

      + Whitespace handling has been adjusted to more closely match Compass.

      + Unknown commands are now warned about.  Compass seems to quietly ignore
        unknown commands, but it seems helpful for cavern to report them as it
        will help identify any bugs in Survex's parsing of MAK files, and any
        new or undocumented MAK file commands which we don't support.  It can also
        help detect typos in data entry.

      + We now skip to the closing `;` for unknown commands and commands we
        ignore as not relevant to us, whereas previously we're just skip the
        initial character which gives the type of command and then look for
        another command.  This doesn't seem to make any difference in practice as
        none of these commands appear to be able to contain text which could be
        interpreted as a different valid Compass MAK file command.

    * (Microsoft Windows version): The toolchain we use to build this version
      seems to have changed in an unhelpful way.  We've got the build working
      again, but when aven is launched a black window opens first, then the
      aven window opens over the top.  The black window stays around until
      aven is closed.  This extra window doesn't really get in the way of using
      aven, but it's not supposed to be there.  It doesn't seem to be due to a
      change in the Survex code as the 1.2.17 build doesn't do this, but a
      rebuild of 1.2.17 with just the minimum of build system changes does.
      If you have suitable skills help fixing this would be much appreciated.

    * (Microsoft Windows version): Use unlocked file I/O if available, like we
      already do for Unix.  Unlocked file I/O can be much faster in some cases (we
      don't need the locking as we don't do multithreaded file I/O).

    * (Microsoft Windows version): Fix compiler warning in wrapaven.c.

    * (Microsoft Windows version): Work around wx-config --rescomp no longer
      working.  The mingw package of wxWidgets has started to return an empty
      string here.  We don't support building with MSVC, so hardcoding `windres`
      here isn't really a problem in practice.

    * Manual: Document that *set eol default includes x1A (Ctrl-Z) to provide
      compatibility with old DOS text files (it always has done but was missing
      from the documentation).

    * Merge updates to Russian translation.

    * Add the start of a Czech translation.

    * Update unofficial Inno Setup translations for the installer.

    * Drop support for wxWidgets < 3.2.  It is starting to become hard to keep
      everything working with 3.0.0 and the time and effort seems better directed
      to other things.  The last 3.0.x release was 3.0.5.1, released 2020-05-02.
      3.2.0 was released 2022-07-06 and it seems everywhere with wxWidgets packages
      upgraded to 3.2.x some time ago.

    * Test suite:

      + cavern.tst: Test more mixed line ending cases.

      + Turn off tests involving aven and survexport on mingw, as we can no longer
        seem to run these programs during the build.  Rebuilding the last commit
        that worked now fails, so this is not due to a change in the Survex code.
        There is no error message, but bash shows exit code 127 which means it
        failed to run the command.

      + Improve handling of VERBOSE in tests.  Previously VERBOSE showed output
        from all testcases, even ones which passed.  Now we only show output from
        testcases which fail for VERBOSE=1.  Other non-empty values of VERBOSE
        continue to show all output for cavern.tst and smoke.tst, but have the same
        effect as VERBOSE=1 for other tests.

      + compare.tst: Fix to actually work, support --help, and allow comparing
        cavern runs which fail.  This script is not run as part of the automated
        tests but assists manually comparing two versions of cavern on the same
        data which can be helpful for debugging and during development.

    Changes in 1.4.17 (2025-03-20):

    * aven: Add support for exaggerating Z.  You can now set a Z scale factor
      from 0.1 to 10.0 via a new widget on the toolbar.  Fixes #49.

    * aven: The cavern log window now chooses foreground and background colours
      based on the desktop's light mode/dark mode setting.  Previously it
      used the default window background colour but always used black text, which
      made it hard to read with a dark desktop theme.  (The wxWidgets API to detect
      dark mode is new in 3.2, so if built with wxWidgets 3.0 then we assume
      light mode.)

    * aven: The station search feature now uses the standard search
      widget on GTK 3.6 or later and on macOS.  There's now a placeholder
      text shown when there's no search to make it clearer what this
      widget is for.

    * aven: There's currently a cavern bug where it can fail to identify all
      traverses which are not involved in loop closure, which results in the .3d
      file contains error information for them (unfortunately this seems tricky to
      fully fix).  This error information is always zero, so as a workaround aven
      attempts to detect these so that "colour by error" shows them as "not in
      loop".  This workaround previously only checked for E being zero, but now
      H and V are both also required to be zero.  This should help avoid some very
      low error traverses being incorrectly treated as "not in loop", although in
      practice I've not yet found a real world case where this actually makes a
      difference.

    * aven: Fix the output encoding of `aven --help`, `--version`, etc.
      Previously these were always encoded as UTF-8 which is usually right
      on a modern system, but the terminal could be using a different
      encoding.

    * aven: Reduce startup overhead a little when the terminal has a UTF-8
      locale (which is now the default on most Linux distros).

    * cavern: Fix an "assertion failed" error in some situations when
      equating to a fixed point.  This bug was introduced by changes
      in 1.4.13.  Fixes #143, reported by Juan Corrin.

    * cavern: The syntax of *copyright commands is now checked and a warning
      issued for problems.  The information in the command is still not yet used.

    * cavern: The syntax of *team commands is now checked and a warning
      issued for problems.  The information in the command is still not yet used.

    * cavern: Stop reporting node stats.  These are kind of interesting, but
      with the widespread use of Disto-X and similar devices which can easily
      shoot multiple splay legs from each station means the number of larger order
      nodes has increased and this information is now quite verbose and any utility
      it had has substantially declined.  If these statistics are still wanted then
      they could make a reappearance in the future in aven, with splays excluded
      when counting the number of legs at each station.  Fixes #86, reported by
      Wookey.

    * cavern: Fix wrong "unused fixed point" warning with *solve.

    * cavern: Fix double counting of stations which are referenced both before and
      after *solve.

    * cavern: Suppress loop and component counts if *solve is used.  Our component
      count was often wrong in this case but this looks very hard to fix.  These
      counts are not vital so better to omit than report wrong values.

    * cavern: The "Equating two equal fixed points" warning now lists the
      stations on the same order as they are in the `.svx` file which
      seems clearer.

    * Speed up reading and writing of .3d files.  The time to read a large .3d file
      and just count the stations and legs was more than halved by this change.

    * Simplify handling of errors loading the messages file.  The error
      messages for this case are now stored as separate ASCII strings in
      the executables which reduces the startup overhead a little as we
      no longer need to scan them and potentially reencode them.

    * img library: The img struct's filename_opened member was always NULL when
      used outside of Survex (and set but never actually used inside of Survex)
      so it has been removed.  If you are referencing it in your code then instead
      use the filename you passed to img_open_survey() when opening the file.

    * Documentation: Add details of warning about future dates in *date.

    * Documentation: Added new manual chapter on the img library.

    * Documentation: Improve comments document API in img.h.

    * Testsuite: Add proper test coverage for `*ref`.

    * Merge updates to Russian translation from Vasily Vl. Suhachev.

    * Portability: Eliminate unintended use of a C++17 feature (static_assert
      with only one argument).

    * Portability: Avoid compiler warnings/errors in getopt code by properly
      declaring getenv().

    Changes in 1.4.16 (2025-02-21):

    * aven: Improve "Colour by Survey".  Surveys whose names only differ in the
      final character tended to get visually similar colours (often
      indistinguishable), but now should get very different colours.  Reported by
      Eric C. Landgraf and Patrick Warren.

    * aven: Add "Find" item to right-click menu on survey tree which triggers a
      search for the survey or station that was right-clicked on which highlights
      with a yellow blob on each station, like double-clicking used to before
      1.2.36.  Requested by Patrick Warren.

    * cavern: Fix calculation of convergence which could incorrectly give zero
      with some PROJ versions < 9.3.0.  Unclear exactly which versions are
      affected, but seen with PROJ 8.2 and can't affect PROJ >= 9.3.0.  Reported by
      Eric C. Landgraf.

    * cavern: Report approximate true grid convergence range which provides a way
      to assess if the representative location(s) specified by `*declination auto`
      are suitable.  Fixes #141, reported by Eric C. Landgraf

    * cavern: Support Compass 'C' shot flag.  In Compass this causes flagged legs
      to not be subject to loop closure.  Survex now sets the SDs of such legs to
      1mm, so flagged legs can still move slightly during loop closure.  Previously
      Survex ignore this flag entirely.

    * Document Microsoft Windows version requirements.

    * Enable SSE2 by default on 32-bit x86.  Intel CPUs without SSE2 were
      discontinued ~18 years ago so it seems very unlikely anyone is actually still
      using one for Survex.  We keep hitting testcase failures due to excess
      precision from 387 FP instructions, and the time spent adjusting testcases to
      avoid these would be better spent on new features, etc.

    * Tighten up charset name parsing a little.

    * Merge updates to Russian translation from Vasily Vl. Suhachev.

    * Various minor improvements to documentation.

    * Various minor improvements to test coverage.

    Changes in 1.4.15 (2024-12-24):

    * aven: Avoid infinite redraw loop if GDAL gives an error loading geodata to
      overlay.

    * aven: Turn off full-screen mode bodges when running on macOS 10.7 or later.
      Fixes #110

    * aven/survexport: (Microsoft Windows version): Enable GDAL support so you
      can now overlay geodata (in aven) and export shapefiles.

    * cavern: Remove now-bogus assertion which can fire when there's a survey not
      connected to any fixed points (since 1.4.10 made unconnected data a warning
      instead of an error).  Reported by Philip Balister.

    * (Microsoft Windows version): Strip debug data from .exe and .dll files which
      reduces the installer size by around 5%.

    * Testsuite: Normalise -0.00 in DXF bounds too to avoid possible test failures
      on x86.

    Changes in 1.4.14 (2024-12-11):

    * aven/survexport: Add support for exporting shapefiles.  This requires GDAL so
      currently isn't enabled in the Microsoft Windows build.  Thanks to Eric C.
      Landgraf for testing.  Fixes #87.

    * cavern: If *date with just year is followed by a blank, cavern expects a date
      range and gives an error if another date doesn't follow.  Bug was introduced
      in 1.4.13.

    * aven/cavern: Use ′ and ″ for feet and inches.

    * Documentation: Add some details on how to handle Toporobot "serie" station
      naming.

    * Updates to Bulgarian, Hungarian, Russian and Slovak translations.

    * Testsuite: Adjust lollipop testcase to pass on i386 where excess precision
      was changing which station was reported as the southernmost of multiple
      candidate stations).

    Changes in 1.4.13 (2024-12-01):

    * aven:

      + Don't show crosses on anonymous stations since they just clutter up the
        display (especially for anonymous splays).  Suggested by Andrew Atkinson.

      + Fix 1.4.10 regression in plotting of station names.  Each anonymous station
        was blocking out a small rectangle which no actual station name could
        overlap.  Reported by Špela Borko.

      + Reduced start-up time by only initialising GDAL if we have overlays to
        show.

      + (Microsoft Windows version): Avoid recurring "GDAL support not enabled in
        this build" message box.  This message is now only shown once if you try to
        add an overlay.  Reported by Špela Borko.

    * cavern:

      + Update to use v14 of the IGRF model for calculating declinations.
        This was issued in November 2024 and should give slightly more accurate
        declinations for surveys made since 2015.  Fixes #137.

      + The component count was wrong in some cases, and we calculate the number
        of loops using this component count, so the loop count would also be wrong
        by the same amount in these cases.

      + The component count and loop count are now reported when there are
        unconnected survey stations.

      + *date now supports ISO format dates.  Fixes #96, reported by Milosch.

      + *date now supports date types "surveyed" and "explored" (existing usage
        without an explicit type is interpreted as "surveyed").

      + If the output directory isn't writable or doesn't exist we would complain
        that we can't create the .err file - now we try to create the .3d file
        first so complain about that instead which seems more helpful.  Reported by
        Eric C. Landgraf.

      + When inventing a fixed point we now avoid picking a fixed point which is
        only attached to nosurvey legs if there's another option.  The code was
        already meant to do this but it was buggy and we lacked a testcase for this
        situation.

      + Survey network reduction now finds some delta-star opportunities which were
        being overlooked.  This allows more complicated networks to be reduced
        further so fewer and/or smaller matrices need solving, which is faster.

      + Survey network reduction now handles a "lollipop" with a fixed stick end
        specially which is a little bit faster.  A more visible consequence is
        fewer "Solving one equation..." messages when solving a complex survey
        network.

      + Survey network reduction now makes use of articulating legs to split up the
        problem a little more, so we will often now solve more but smaller matrices
        which should be faster.

      + Assigning matrix row numbers now identifies equated stations in a slightly
        more efficient way.

    * dump3d: Provide a way to get ISO format dates output.

    * Documentation:

      + Improve documentation of *date in the manual.  When a partial date is
        specified (just a year, or a year and month only) the documentation claimed
        the centre of that year or month is used but actually this case is treated
        as a date range covering the whole year or month (respectively).  The end
        result is effectively the same as what was previously documented though
        since the centre of a date range is used as the date for calculating
        automatic declinations and is the date used by aven.

    * Test suite:

      + Adjust hpglexport testcase to avoid i386 excess precision causing one of
        the HPGL coordinates to differ by one from its value calculated without
        excess precision.

    * Assorted translation updates.

    Changes in 1.4.12 (2024-10-23):

    * aven:

      + (Microsoft Windows version): Geodata overlays are (hopefully temporarily)
        no longer available in the pre-built version of Survex installed by the
        Microsoft Windows installer.  We use the GDAL library to load them and
        there's a hard to debug problem during DLL initialisation somewhere in its
        dependency tree.  If you really need geodata overlays, the 1.4.9 installer
        still works.  Thanks to Wookey for extensive testing to investigate the
        problem, and to everyone else who reported this.

    * cavern:

      + A leg with the same station as from and to is now only a warning in
        Compass data.  Compass itself seems to quietly ignore such legs, but
        they seem worth warning about.  In native Survex data this is still
        an error.

      + Short survey and station names are now stored without an extra memory
        allocation.  On a 64-bit platform (most modern computers) we can store
        name components up to 7 characters in this way; on a 32-bit platform
        up to 3 characters.  On a large dataset which needs large matrices
        solving this reduces cavern's memory usage by 3.5MB (~4.5%).  It's
        also fractionally faster (but only ~0.05% which is not normally even
        measurable).

      + Assigning matrix row numbers to stations is now faster and allocates
        less memory.

    * (Microsoft Windows version): The Microsoft Windows installer is now
      named `survex-microsoft-windows-1.4.12.exe`.  The old name was
      `survex-win32-1.4.11.exe` but the "win32" is now misleading as it's been a
      64-bit build since 1.4.9.  Reported by Wookey.

    * Testsuite:

      + dump3d.tst: Add tests of img library's survey filtering.

      + cavern.tst: Normalise `-0.00` to `0.00` in JSON test output before
        comparing with expected output.  We can get -0.00 on x86 due to excess
        precision.

    * img library:

      + Survey filtering now works correctly for files which use a survey level
        separator other than `.`.  Patch https://github.com/ojwb/survex/pull/14
        from Thomas Holder.

      + Reading a v7 or earlier .3d format extended elevation with survey filtering
        was failing to set is_extended_elevation.

    Changes in 1.4.11 (2024-08-14):

    * aven:

      + Add imperial scales for export and printing.  Fixes #132, reported by Eric
        C. Landgraf.

    * aven/survexport:

      + HPGL export now uses pen 2 for splays and pen 3 for surface legs.  Partly
        addresses #60.

      + HPGL export now supports scaling (previous the scale was always
        1:40000).

      + KML export now distinguishes surface legs and splays using different
        line styles.  Partly addresses #60.

      + Remove Skencil export support.  The last release of Skencil was in 2005.
        There was an attempt to revive the project in 2010, but that didn't lead to
        another release and seems to have petered out.  No current Linux distro (or
        other package system) seems to have Skencil packages, and the current git
        version still appears to require Python 2 which is being phased out.

    * cavern:

      + Support `*data ignore` to allow ignoring a block of survey data lines.
        Closes #114, reported by Alastair Gott.

      + Report error for bad final reading in `*data` command (previously such a
        bad reading was quietly ignored).

      + If the survey in `*end` doesn't match that in `*begin` the location of
        that `*begin` is now reported as well - the second message here is new
        for example:

         badbegin.svx:6:8: error: Survey name doesn't match BEGIN
          *end   bar
                 ^~~
         badbegin.svx:4:13: info: Corresponding BEGIN was here
          *begin      foo
                      ^~~

      + Now shows a context line for a reading which was on the previous line,
        which can happen for interleaved data styles.

      + Warn when a token is not followed by a blank, comment or end of line.
        This is an unintentional tokenisation oddity which has been present
        for a really long time.  We don't want to break files that rely on this
        (even if they likely only do accidentally) so emit a warning rather than
        an error.

        This warning can easily be eliminated by adding a space where indicated,
        which will work with old and new Survex versions.  Fixes #135.

      + Errors and warnings which report an unexpected token now report a
        contiguous span of letters and numbers rather than just letters in cases
        where a number can't follow (which is the majority of cases).

      + If `*require` isn't satisfied, the `*require` line is now shown for
        context (especially helpful if there's a comment after the command noting
        the reason for the requirement, as we now suggest in the manual).

      + `*require` version parsing improved - spaces are no longer tolerated in
        a version number and trailing junk after the version number is now
        handled more consistently.

      + Fixed several situations in which the highlighting of the context for a
        diagnostic was off by a small number of columns.

      + Optimise building of matrix during network solving.

      + Enhancements and fixes to reading Walls WPJ and SRV files:

        - After reporting an error for an unsupported datum, we now set the datum
          to WGS84 to prevent triggering further errors from code which tries to
          use the datum.

        - Parse Walls WPJ commands as alphanumeric rather than alphabetic tokens,
          which better matches how Walls parses them.  This only makes a difference
          in the error message when we don't recognise a WPJ command.

    * Documentation:

      + Note `feet` are international feet and how to select a different
        definition in `*units` docs.

      + Document `grads` are also known as "neugrads" and "gons" in `*units` docs.

    * Assorted translation updates.

    * testsuite:

      + Fix bug in normalisation of `-0.00` to `0.00` in DXF output before
        comparing with expected output.

    * Update and improve vim syntax highlighting:

      + `*cartesian` added

      + `*data ignore` added

      + `mils` units now highlighted as deprecated

      + `UP` and `DOWN` are no longer highlighted anywhere in a command

      + `U`, `D`, `LEVEL`, `-V`, `+V`, `.`, `..` and `...` now highlighted in data
        lines

      + Repeated `NOT` in `*flags` is now highlighted as an error

      + Fix error highlighting for unquoted `*include` to not flag an error just
        because there's a comment after the filename

      + Fix error highlighting for unquoted `*include` to work when there's
        whitespace between `*` and `include`

    Changes in 1.4.10 (2024-08-05):

    * aven:

      + Use a fixed rotation rate for rotating the view to North, South, East or
        West (shortcut keys `N`, `S`, `E` and `W`).  We were using the same
        variable rate which auto-rotation does for this case, but really these are
        just animations to help the user see the change that's happening, so a
        fixed rate makes more sense (and is what tilting to plan or elevation
        does).  The new fixed rotation rate for this is double what the default
        variable rate was, which means the longest rotation (e.g. from S to N)
        takes 3 seconds rather than 6.

    * aven/survexport:

      + Fix syntax of shot flags in PLT export (incorrect since introduced in
        1.4.6).

      + Map Survex duplicate flag to `L` shot flag in PLT export.

      + Invent shorter names for anonymous stations in PLT export.  The PLT file
        format documentation says station names can be up to 12 characters, but the
        ones we generated were longer than this which is liable to trip up
        consumers of this format that only allow for the specified length.
        We now generate names using a sequential counter with a two character
        prefix so they should fit in the 12 character limit for any cave
        survey.

      + 3D export now includes all leg and station flags.

    * cavern:

      + Unconnected survey stations are now handled as a warning, whereas
        previously this was an error.  This is necessary when processing Walls data
        where it seems having hanging surveys is the norm, and Walls itself only
        warns about them.

        The support is also enabled for native Survex data since it allows viewing
        the connected parts of a survey with missing connections without having to
        comment out the unconnected parts (and then remember to fully uncomment
        once connections are surveyed).  Fixes #16, reported by Duncan Collis.

        Currently the component count and loop count are not shown in this case.

      + Avoid multiple reports of an unconnected survey station.  This could happen
        in some cases where a group of equated stations had more than four legs
        connected to it.

      + Fix missing report of unconnected survey station.  We aim to report at
        least one station in every unconnected piece of survey, but if a piece had
        been simplified to a single station which was anonymous (e.g. a disto splay
        shot) then we wouldn't report anything for that piece.  Now we find the
        traverse that was attached to it and report the next station along that
        traverse.

      + Report file and line location each unconnected survey station.

      + This warning now says either `*entrance` or `*export` depending on which
        it actually was:

          Station "bar.1" referred to by *entrance or *export but never used

      + Fix several cases of mishandling comments without blanks before them:

        - After an anonymous station.

        - After an ignored reading.  The `ignore` would incorrectly also skip the
          comment character and any characters which followed up to the next blank
          or end of line.

        - In a `*alias` command.

        - Diagnostic highlighting could continue into a comment.

      + New `*cartesian` command which supports different orientations of
        `cartesian` style data.

      + Anonymous stations are now supported in `cartesian` style data.

      + `*fix a reference` (without any coordinates) is now an error.  The
        `reference` token provides a way to have a list of known fixed points which
        are not expected to all be currently used, while omitting the coordinates
        provides a way to specify a point to arbitrarily fix rather than rely on
        cavern picking one.  Allowing both together doesn't really make sense.

      + Improve check for 180° backclino to suppress the warning about a compass
        reading on a plumbed leg (introduced in 1.4.8) to allow a small tolerance
        on the value.  Previously the check wasn't working on x86 Linux for
        example.

      + When showing a line as the location of a diagnostic we now render any
        tab character as a single space which means the `^~~~~` highlight length
        is now correct even when the highlighted part contains tabs.  This only
        affects use from a terminal as the highlight was already correctly handled
        when viewing the log in aven.

      + Enhancements and fixes to reading Walls WPJ and SRV files (thanks to Eric
        C. Landgraf and Joe for a lot of great feedback from testing with large
        datasets):

        - The `RECT=` option is now fully supported.

        - Fix `#DATE` with an active `.REF` to act like `DECL=`.  This matches what
          the documentation says and what Walls seems to actually do.

        - Allow completely omitting the clino on a wall shot (with `ORDER=DAV` or
          `ORDER=ADV`).

        - Resolve WPJ `.PATH` relative to innermost containing book.

        - Handle an empty Walls station name.  Walls allows a station with an
          explicit prefix to have an empty name, e.g. `PEP:`.  The Walls
          documentation doesn't mention this, though it also doesn't explicitly say
          the name can't be empty.  This quirk seems unlikely to be intentionally
          used and Survex doesn't allow an empty station name, so we issue a
          warning and use the name `empty name` (which has a space in, so can't
          collide with a real Walls station name which can't contain a space) - so
          `PEP:` in Walls becomes `PEP.empty name` in Survex.

        - Flag stations with explicit Walls prefix as exported.

        - Fix setting empty Walls macro with a comment right after it.

        - Walls quietly ignores junk after the numeric argument in `TYPEAB=`,
          `TYPEVB=`, `UV=`, `UVH=`, and `UVV=`.  This seems to be an undocumented
          feature/bug so Survex emits a warning and skips the junk.

        - After an unknown Walls option we now process the rest of the line.
          Previously we were skipping the rest of the line.

        - We no longer skip the rest of the line after a bad Walls `ORDER=` option.

        - Correct the reported column for some Walls option diagnostics.

        - Support explicit units on Walls clino readings.

        - Allow `#` in Walls station names.  This is explicitly documented as not
          allowed, but the documentation doesn't match the implementation and `#`
          is present in some real-world data.

        - Improve handling of Walls `RESTORE` error.  Highlight the position in the
          line and don't skip the rest of the line.

        - Don't warn about `INCH=` with a zero argument since that's the one case
          of it we do handle!

        - Fix not to skip the rest of the line after Walls `INCH=` option.
          We currently don't support `INCH=` so we warn about it, but we were
          skipping the rest of the line, then trying to read and discard the
          argument to `INCH=` which gave an error.

        - Relax handling of Walls `CASE=`.  It's not documented, but Walls32.exe
          quietly treats unknown values as "Mixed".

        - Support DM and DMS format for latitude and longitude in Walls `#FIX`,
          e.g. `W97:43.875` and `W97:43:52.5` .

        - Treat a zero length leg with finite variance like a Survex `*equate`.

        - Apply Walls variance overrides to survey legs.

        - The optional instrument and target heights are now parsed, but their
          values are currently ignored.

        - The delimiters around LRUD data are now parsed, but the LRUD data between
          them is currently ignored.

        - If a `#SEGMENT` value looks like a set of Compass shot flags (i.e.
          consists only of upper case characters from `CLPSX`, optionally prefixed
          with a `/` or `\`) then we interpret them as Compass shot flags (except
          that `X` is mapped the same way as `L`).  This is apparently a common way
          to use `#SEGMENT`, and unlikely to be triggered accidentally.

        - Avoid a doubled directory separator when building Walls path names.

    * documentation:

      + The manual has been converted from DocBook to reStructured Text.  The
        plain-text format is much easier for making changes, and for users the
        output from sphinx looks nicer and has extra features (like built-in
        "Quick search" in the HTML output).

        The plain text version of the manual is no longer generated.  Sphinx can
        produce one but the .rst sources actually seem more readable for anyone
        wanting to read the manual in plain text.

        The extra targets to generate the manual in RTF and PostScript
        have been dropped as I doubt they are still used (we stopped
        providing them on the website years ago).  They could probably be
        reinstated if there's a demand for them.

        The conversion was partly automated followed by a full pass over the
        result fixing issues with the automated conversion.  We took the
        opportunity to also review the content and update or remove out of
        date and other incorrect information, and to reorder some of the content.

      + Document all the statistics in the `.err` file

      + Document PLT export.

      + Minor improvements to --help output

      + The HTML version of the 1.4.9 manual was missing the Walls chapter
        and had messed up paging links around it (due to the new CMAP chapter
        accidentally also being given the filename `walls.htm`).  Reported by Eric
        C. Landgraf.

      + Document we don't enforce Walls' station or prefix length limits.

      + Document handling of Walls `#NOTE`.

      + Fix documentation of Walls `FLAG=` which is correctly handled, not skipped.

      + Document how to compare Walls and Survex output via Shapefile.

      + Document how to suppress unused fixed point warning in Walls SRV.

    * testsuite:

      + Add testcase for Walls `#units order=da`.

      + Add expected output for more testcases

      + Add testcase for exporting .3d files.

      + Normalise `-0.00` to `0.00` in DXF output before comparing to avoid bogus
        test failures due to excess precision on x86 when using 387 FP
        instructions.

      + Add test of DXF export with full coordinates.

    * translations:

      + Diagnostics can now use positional arguments which sometimes allows a
        more natural word order in a translated message.

    Changes in 1.4.9 (2024-07-04):

    * aven:

      + Support showing geodata overlays in Aven.  We use the GDAL library to load
        the data, so this should work for any format which GDAL supports so long as
        it can be read from the filing system and is geo-referenced vector data -
        see https://gdal.org/drivers/vector/index.html for a list.  Currently the
        dialog to select a file defaults to showing GPX, KML, GeoJSON and shape
        files - set the filter to "All Files" to choose other formats.

      + Reimplement display of cavern output.  The old version turned the log into
        HTML and displayed it using wxHtmlWindow, but that adds a lot of overhead
        and is especially inefficient if there are many diagnostics - cavern could
        finish almost instantly yet aven could take many seconds to process the
        output.  The new version renders directly from the log data.  It should
        have most of the features from before - the only missing feature I'm
        currently aware of is that you can't now select and copy text from the log
        window, which wxHtmlWindow provided for free.  If people miss this feature,
        we could add it to the new implementation.

      + (Microsoft Windows version): Clicks in the cavern log window which load
        files into an editor now protect the filename if it starts with a dash
        to prevent it being interpreted as a command line option.  We already
        do this for other platforms, but weren't on Microsoft Windows on the
        assumption that it isn't needed because the filenames will be fully
        qualified, but that may not be the case if aven if run by hand from the
        command line or from some other launcher.

    * cavern:

      + Add support for processing Walls format survey data (.SRV and .WPJ files).
        This support is somewhat experimental but at a point where it seems useful
        to make it easier for people to try out.  See the manual for a list of
        known shortcomings.  Thanks to Eric C. Landgraf for a lot of testing and
        encouragement.

      + Fix bug with Compass DAT diving data.  If a survey uses the depth gauge
        then since 1.4.6 we set its style to "diving", but we weren't clearing that
        so all surveys after that in the same DAT file were also set as "diving".

      + When parsing of Compass DAT files we report errors in more cases if the
        input doesn't conform to the format we expect, rather than potentially
        quietly misinterpreting the data.

      + *entrance now suppresses "Unused fixed point" warning.  This warning is
        intended to catch typos, which is much less likely for a station named
        twice.  It's also reasonable to use only *fix and *entrance on a station at
        the entrance of an unsurveyed cave.

      + Highlight plumbed clino readings fully in diagnostics.  Now the full reading
        is highlighted instead of just the first character.

      + Report location of previous fix after "already fixed" error/warning.

      + Use "info" diagnostic category for "Originally entered here" message.  This
        is more logical as the original *begin isn't something to be warned about,
        only the reentering is.  This was only a warning before because we didn't
        used to have "info" diagnostics.

      + Use "info" diagnostic category for message about not reporting further
        uses of a deprecated feature.  Previously this was a warning, but the newer
        "info" category is more appropriate here.

      + The message about inventing a fixed point is now an "info" diagnostic which
        allows us to report a location which is where that station is defined,
        which may be useful to the user.

      + Make highlighting position in error reporting more robust.  We no longer
        try to highIight if we calculate a negative column offset, when previously
        we would print billions of spaces.  As far as I know this has never
        happened in a released version.

      + Error messages which report the program name now remove any ".exe" suffix.
        This helps the testsuite by making the expected output the same
        cross-platform, but also seems slightly nicer for users.

    * dump3d:

      + The timestamp reported by DATE_NUMERIC is now printed portably.  Previously
        we were assuming that a time_t is the same size as a long int, which is not
        true on all platforms.

    * manual:

      + (Microsoft Windows version): Update information about installation
        with/without admin rights.

      + Summarise support for reading CMAP data and its assumptions and
        limitations.

      + Mention Compass, Walls and CMAP support in the importing data howto
        section.

      + Drop mention of Rosetta Stal from the manual.  The referred to link from
        our website was removed in 2015 because Rosetta Stal hadn't been updated
        for 13.5 years at that point.  Now the domain it was available from has
        lapsed and is a domain squatter "for sale" page.

    * img library:

      + The coordinates in CMAP data are in feet but we were dividing rather
        than multiplying by the conversion factor to get metres so all
        coordinates were about 10.76 times too large.

      + Stations in CMAP "station" variant XYZ files are now flagged as
        underground (as they always have been for "shot" variant XYZ files).

      + When reading CMAP XYZ files, we no longer emit duplicate img_LABEL for
        stations in loops.

      + A CMAP XYZ file without a survey title is now handled correctly (this was
        reporting a bogus "Out of memory" error).

      + The img.h header now defines constants IMG_VERSION_SURVEX_POS, etc for the
        values reported in the version field for non-.3d formats.

      + (Microsoft Windows version): Workaround limitation of Microsoft's C
        library so we handle dates before 1970 in Compass PLT files, CMAP XYZ
        files, and older format .3d files.  Previously these were reported
        as "unknown date".

    * We now support overriding the location of support files by setting the
      SURVEXLIB environment variable.  We no longer look at the srcdir
      environment variable for this.

    * (Microsoft Windows version): The installer is now created automatically
      on Github actions, which has required a few changes.  It now packages a
      64-bit build, and is created with Innosetup 6.3.2 which no longer supports
      Vista.  The installer is also now significantly larger, which is mostly
      because we now need to include a large number of DLLs, most of which are
      dependencies of the mingw64 FFmpeg and GDAL packages.

    * (Microsoft Windows version): If the directory where we expect the PROJ
      support files to be does not exist for some reason we now avoid triggering
      a segmentation fault in PROJ.

    * Build system:

      + The GDAL library is now required to build Survex.

      + (Microsoft Windows version): The probe for GL and GLU libraries now also
        checks for Microsoft's non-standard library names.

      + Correct configure --help output for --enable-werror for which the default
        is actually "no" rather than "maintainer-mode".

    * testsuite:

      + aven.tst: Skip a testcase when running on mingw as it seems to hang there.
        We already skip this testcase on macos for what appears to be the same
        problem.

      + Fix comparison of output to work on platforms using DOS line endings.

    Changes in 1.4.8 (2024-04-23):

    * cavern:

      + The warning for a compass reading on a plumbed leg was already suppressed
        for a compass or backcompass reading of 0, but is now also suppressed for a
        backcompass of 180° (or equivalent) which seems to be common in some Compass
        datasets, but also seems sensible generally.  Thanks to Simeon Warner for
        sharing some data which triggered such warnings.

      + The error for when a survey and station use the same name is now also
        emitted in the case where a name was used first for a station, and then as
        a survey on an explicitly prefixed name.  Closes
        https://github.com/ojwb/survex/pull/4, reported by Thomas Holder.

      + The error for when a survey and station use the same name now highlights
        the problematic name within the line shown for context.

      + Fix the reported token string reported by some errors with readings.  This
        happened to work on at least x86-64 Linux, but the code was invalid and
        failed on some architectures.

    * Fix to build with newer FFmpeg versions.

    * (Microsoft Windows version): The installer now offers the choice to install
      for just the current user, which allows installing Survex without admin
      rights.

    * (Microsoft Windows version): Fix problems with valid coordinate systems being
      rejected and aven's cavern log window not showing output.  Reported by
      Peter Mašič, Špela Borko, Răzvan Dumbravă and detrito.  Thanks especially to
      Špela Borko for a lot of testing to help track down the cause.

    Changes in 1.4.7 (2024-04-07):

    * cavern:

      + When using *declination auto we report the range of calculated declinations
        for each location specified.  After doing this we now reset the range
        information we're tracking.  Previously we'd misreport the range for
        the second and subsequent locations.

      + Avoid undefined behaviour on handling filename fallback for filenames
        containing non-ASCII characters.

      + Show context line with relevant item highlighted for more errors and
        warnings.

      + The dynamic string handling routines are now more efficient.

      + Fix memory leak if a Compass MAK file opens folders it doesn't close.

      + Fix handling of clino-less legs in Compass DAT.  These would cause cavern
        to fail with a lot of "NaN" messages.  Now they're treated as having a zero
        clino with a standard deviation based on the leg length, just like in .svx
        files.

    * img library:

      + Compass PLT: Treat LRUD readings > 900 as omitted readings, which matches
        what Compass does.  Thanks to Larry Fish for clarifying this.

      + Avoid undefined behaviour after realloc().  We were adjusting a pointer
        within the reallocated block by subtracting the old block address and
        adding on the new one.  Technically this is undefined behaviour, although
        in practice it seems likely it'll work and we've not seen misbehaviour due
        to it.  However it's easy to avoid by calculating the offset before the
        realloc().

    * Portability:

      + Provide prototype for getopt() to avoid warnings with very recent compiler
        versions.

      + Avoid using sprintf(), which now triggers warnings on some platforms.

    * Build system:

      + Add configure --enable-werror option to turn compiler warnings into errors.

    * Manual:

      + Expand details of Compass MAK CRS support.

      + Replace very out of date information about binary RPM packages.

    * Minor translation updates.

    * (Microsoft Windows version): Now uses PROJ 9.3.0 and ships all of the
      ancillary files that PROJ comes with.  Hoping this fixes use of coordinate
      system EPSG:3912 failing, which was reported by Peter Mašič but I've not
      managed to reproduce.

    Changes in 1.4.6 (2024-03-07):

    * cavern:

      + Workaround bug in PROJ < 9.3.0 with projected coordinate systems with
        northing/easting axis order (such as EPSG:3042) which results in the grid
        convergence being wrong by about 90°.  Reported by Patrick Warren on the
        mailing list.

      + If *declination auto was used before *cs out we would incorrectly calculate
        the grid convergence as 0.  We now handle this case correctly by
        calculating lazily when we first read a compass reading, and report an
        error if the output coordinate system hasn't been set by then.

      + When opening a file, cavern has fallback handling if the file isn't found
        to help people processing datasets from platforms with case-insensitive
        file systems.  Previously cavern would fold the filename to lowercase and
        retry.  Now if this fails, it will also try the lower case version but
        with the initial character of the leaf in upper case, and finally folding
        the whole specified filename to upper case.

      + Dynamically pick a suitable level separator character and store it in .3d
        file, instead of it being hard-coded to '.' (we still use '.' unless it
        has been *set as a "name" character, or for Compass DAT/MAK files unless it
        has been used in a station name).  This is a step towards addressing the
        situations raised by Thomas Holder in https://github.com/ojwb/survex/pull/4
        and https://github.com/ojwb/survex/pull/5 .

      + Compass DAT files:

        - The shot flag S is now understood to indicate a splay.

        - The shot flag P is now interpreted as marking surface data.  This flag
          is described as "Exclude this shot from plotting", but the use suggested
          in the Compass docs is for surface data, and legs flagged with it "[do]
          not support passage modeling".  Even if it's actually being used for a
          different purpose, Survex programs don't show surface legs by default so
          the end effect is at least to not plot as intended.

        - Surveys which indicate a depth gauge was used for azimuth readings are
          now marked as STYLE_DIVING in the 3d file.

        - Compass and clino corrections are now implemented for backsights.

        - The tape correction in Compass DAT files is now handled correctly.  The
          specified value is in feet, but cavern was incorrectly treating it as
          being in metres.

        - We now handle the newer 15 character "FORMAT:" encoding.  Previously
          cavern wouldn't detect when there were backsights in this case.

        - We now treat survey date January 1st 1901 as "no date specified" since
          this is the date Compass stores in this situation, and it seems very
          unlikely to occur in real data.

        - In Compass DAT files a dummy zero-length leg from a station to itself is
          used to provide a place to specify LRUD for the start or end of a
          traverse (depending if dimensions are measured at the from or to
          station), and so we no longer issue a warning about equating a station to
          itself for DAT files.

      + Compass MAK files:

        - The base location command is now understood.  This is how Compass
          specifies a location to calculate magnetic declination at, and we
          now handle this like Survex's native "*declination auto X Y Z".

        - Survex uses the specified UTM zone and datum provided the combination can
          be expressed as an EPSG code (lack of any EPSG codes for a datum suggests
          it's obsolete; lack of a code for a particular datum+zone combination
          suggests the zone is outside of the defined area of use of the datum).
          Example Compass files we've seen use "North American 1927" outside of
          where it's defined for use, presumably because some users fail to change
          the datum from Compass' default.  To enable reading such files we return
          a PROJ4 string of the form "+proj=utm ..." for "North American 1927" and
          "North American 1983" for UTM zones which don't have an EPSG code.
          Please let us know if support for additional cases which aren't currently
          supported would be useful to you.

        - Folder commands are now understood.

        - Flag fixed stations as entrances.  Experimentation with Compass shows
          this is how it treats them ("distance from entrance" in a .DAT file
          counts from 0 at these points).

      + We now support reading Compass CLP files.  These are very like DAT files,
        except they contain loop-closed data.  You might find this useful if you
        want to keep existing stations at the same adjusted positions Compass gave
        (for example to be able to draw extensions on an existing drawn-up survey),
        or if the original DAT file has been lost but you still have the CLP file.

    * aven:

      + Fix OpenGL scaling on high DPI displays with wxWidgets 3.0. Reported by
        Philip Balister.

      + Split the filters for DAT and MAK files in the File->Open drop down list.
        It seems more likely you'd want to see one type or the other, not both
        together.

    * aven/survexport:

      + Fix survey filtering when reading Compass PLT files.

      + .json,.kml: Enable export of surface legs.  Currently surface and
        underground legs aren't differentiated in these export formats when both
        are enabled.

      + .3d: The coordinate system is now set.

      + .svg: Equated stations now get their correct names in the id attribute
        of <circle> tags.  Previously one of the names would be repeated for
        all of a set of equated stations.

      + .plt:

        - Anonymous stations previously resulted in an empty name in the PLT
          file.  This isn't explicitly disallowed by the PLT format description,
          but Compass' viewer gives an error for such lines.  Now we invent names
          by encoding the station coordinates which should be unique.

        - The S shot flag is now set for splays, and the P shot flag (hide from
          plotting) is set for surface legs (which matches the use suggested in the
          Compass docs).

    * img library:

      + Fix bug handling timestamps before 1970.  In C signed integer division
        rounds towards zero, which previously resulted in timestamps before 1970
        getting rounded to the end of the day instead of the start when converting
        them to a count of days so they'd be off by one day unless the time was
        midnight.  This affected reading v3-v7 format 3d files with IMG_API_VERSION
        set to 1 and writing v8 format 3d files with IMG_API_VERSION set to 0 (the
        default).

      + Improve Compass PLT support (many of these are Compass features added
        since Survex's support for Compass was originally added):

        - Survey dates are now handled fully.  We treat survey date January 1st
          1901 as "no date specified" since this is the date Compass stores in this
          situation, and it seems very unlikely to occur in real data.

        - LRUD data is now translated to img_XSECT and img_XSECT_END.

        - We now infer img_SFLAG_ENTRANCE for stations where the "Distance From
          Entrance" field is present and zero.

        - The shot flag L is now translated to img_FLAG_DUPLICATE.

        - The shot flag S is now translated to img_FLAG_SPLAY.  A station at the
          far end of a shot flagged S gets img_SFLAG_WALL set since the Compass PLT
          format specification says:

    	  The shot is a "splay" shot, which is a shot from a station to the
    	  wall to define the passage shape.

        - The shot flag P is now interpreted as marking surface data.  This flag
          is described as "Exclude this shot from plotting", but the use suggested
          in the Compass docs is for surface data, and legs flagged with it "[do]
          not support passage modeling".  Even if it's actually being used for a
          different purpose, Survex programs don't show surface legs by default so
          the end effect is at least to not plot as intended.

        - The d plot command is now supported (previously img failed to parse
          PLT files using this command) - it's like D but implies the P shot flag.

        - If a PLT file only uses one datum and it is "WGS 1984" then the UTM zone
          is converted to the appropriate EPSG code and this is reported as the
          coordinate system.  Other datums could be handled, but the mapping to
          EPSG code is less simple.  Also it seems Compass supports at least
          24 datums but it doesn't document all the strings it uses for them.
          Files with multiple datums could be handled too, but we'd need to convert
          coordinates to a common coordinate system in the img library, which would
          need it to depend on PROJ.  Please let us know if support for more and/or
          mixed datums would be useful to you.

        - Duplicate img_LABEL items are no longer returned - this used to happen
          for stations where more than two shots met within a single survey.

        - We now infer img_SFLAG_EXPORTED for any station that appears in more
          than one survey in the PLT file.

        - We now set flag img_SFLAG_FIXED for any station which is listed as
          a fixed point in the PLT file.

        - If there's only one non-empty section name in a PLT file and we aren't
          filtering by survey, we now report that section name as the title.  If
          there are multiple different non-empty section names, we still report the
          basename of the file as before.  If we're filtering by survey, we report
          the comment for that survey as before.

        - Fix bug handling PLT with omitted LRUD.  The format specification
          documents that LRUD may be omitted, though it seems Compass never
          actually omits it and at least some versions of Compass failed to handle
          it being omitted too.

    * (Microsoft Windows version): Now using wxWidgets 3.2.4 (was 3.1.6).

    * manual:

      + Document Compass support in detail.

      + Improve NATO mils example.

    * INSTALL:

      + Add a link to the instructions for building from git.  Reported by Andrew
        Northall in https://github.com/ojwb/survex/pull/13

      + Document the requirement for a C99 compiler for building from source.
        We made this a requirement in 1.4.2, but only noted it in NEWS.

    * doc/TODO.htm: Update.

    * Replace references to "libav" with "FFmpeg" since the libav project seems to
      now be defunct, and we've always supported using either.

    * Update build system to eliminate use of obsolete autotools macros and drop
      probes for features that we can safely assume now we require a C99 compiler
      and workarounds for obsolete platforms.

    * Fix compilation warnings from newer compiler versions.

    Changes in 1.4.5 (2023-06-29):

    * aven: Fix rendering of crosses when drawn as sprites.  Reported by echarlie.

    * (macOS version): aven: Fix crash in export dialog.  Fixes #133, reported by
      rixyane.  Thanks to Wookey for testing.

    * manual: Expand docs on connecting to Compass data.

    * Minor translation updates.

    Changes in 1.4.4 (2023-02-03):

    * aven: Fix red line in clino background to be grey (this was introduced in
      1.4.3 and was a debugging change accidentally left in).

    * aven: Accept weird .3d files from Therion which have empty components in
      station names.  That's not really valid by Survex's definition of station
      names, but it's not very helpful to reject such files, so just disable the
      checks that were rejecting this.

      The result is empty entries in the survey tree, but I don't see what we can
      really do that's better than that.

      Reported by Vasily Vl. Suhachev.

    * aven: Make it more obvious you can enter a custom scale by adding a "..."
      entry to the scale combobox - selecting this clears the value and gives focus
      to the combo box text entry. This control has always supported clicking to
      enter a custom scale, but there wasn't really any indication that this was
      possible before.  Partly addresses #132, reported by Eric C. Landgraf.

    * aven: Force export window to resize when the export format is changed as
      different controls are shown depending on the export format.

    * aven: Right-align tilt spin control value in print/export dialog to match the
      bearing spin control.

    * aven,survexport: Add ability to export as Survex 3d which is useful as you
      can filter to a subset of surveys, filter out splays, convert from other
      formats the img library can read, etc.  This feature is a bit rough and ready
      currently but please report issues.

    * dump3d: Add --legs option which converts MOVE and LINE to a single LEG line
      per leg with the from and to coordinates.  Tools which parse dump3d output
      should find this easier to process as it avoids having to track a "current
      position".

    * Update manual to have a complete list of quantities which *calibrate accepts.
      Reported by echarlie

    * cavern.tst: Fix testsuite to work with SOURCE_DATE_EPOCH set.

    Changes in 1.4.3 (2022-05-17):

    * aven: Much improved support for HiDPI monitors on all platforms.

    * aven: When started without a file make sure the window has focus so menu
      accelerators and shortcuts work without clicking on the window.

    * aven,survexport: DXF export now puts splays in a separate layer and uses a
      dotted linetype for them.  Patch from echarlie, see #60.

    * Improved survexport man page to include command line options and a short
      note about DXF export.  Patch from echarlie.

    * Minor translation updates.

    * (Unix version): aven: Fix handling of EGL-based wxGLCanvas (which wxGTK 3.1.5
      has).  Fix a build failure and don't force X11 (as the EGL-based wxGLCanvas
      works on Wayland).

    * (MacOS version): aven: Fix hang on startup without a file.  Fixes #120,
      reported by Enrico Fratnik.

    * (Microsoft Windows version): Now using wxWidgets 3.1.6 (was 3.0.5).

    * img library: Support reproducible builds which create .3d files by not
      embedding a timestamp if environment variable SOURCE_DATE_EPOCH is set.
      Requested by Martin Budaj.

    Changes in 1.4.2 (2022-02-25):

    * aven: Fix to be compatible with FFmpeg 5.0.

    * Improve docs for *cs and *declination.

    * cavern: Fix "*declination auto" not to crash when built with PROJ < 8.1.0.
      Bug introduced in 1.4.0.

    * cavern: For each `*declination auto` command cavern now reports an "info"
      message showing the range of calculated declination values and the dates at
      which the ends of the range were obtained, and also the grid convergence
      (which doesn't vary with time).  Fixes #92, reported by Rob Eavis.

    * cavern: If any of the N-S, E-W or U-D ranges includes an anonymous station
      then also report the range in that direction excluding anonymous stations.
      Patch from Thomas Holder.

    * cavern: The error from a bad `*cs custom` command now highlights the quoted
      string properly.

    * cavern: "FIX command with no coordinates - fixing at (0,0,0)" is now an
      "info" rather than a "warning".  It's not really reporting a problem and the
      ability to omit the coordinates is a deliberate feature.  It is useful for
      the user to know where the "*fix" without coordinates is if they want to
      change the survey to be in real coordinates, so an "info" diagnostic is a
      good fit.  This also means aven will no longer stay on the log view after
      processing a dataset which fixes without coordinates.

    * cavern: If "*fix" is used twice with no coordinates we no longer say
      "FIX command with no coordinates - fixing at (0,0,0)" right before:

      error: Already had FIX command with no coordinates for station "x"

    * cavern: Include errors in Compass .mak files now report the error in the line
      where the included filename is actually specified.

    * cavern.tst: Add test coverage for warnings for *entrance and *export with
      a station which doesn't exist otherwise.

    * aven/survexport: Change JSON export to be valid JSON.  This means the output
      has changed incompatibly, but it wasn't valid JSON before which suggests
      nobody was actually successfully using it. Fixes #128, reported by Pawczak.

    * aven.tst: Skip one testcase on macos as it seems to hang, at least when
      running on the Continuous Integration system.

    * (Microsoft Windows version): The installer is now generated with a much
      newer version of Innosetup.  This means Microsoft Windows Vista is now the
      minimum supported version but 2000 and XP are both many years out of support
      anyway.

    * (Microsoft Windows version): The coordinate system database for PROJ is
      now included so "*cs" now works (broken since 1.4.0).

    * Chinese translation updates from Qingqing Li.

    * Building from source now requires a compiler with support for C99.  C99
      seems to be universally supported by compilers now so we don't expect this to
      inconvenience anyone.

    Changes in 1.4.1 (2021-11-08):

    * This release should work with any PROJ version >= 6.2.0.

    * cavern.tst: Fix to actually run tests when building outside the source
      tree.  Previously files for testcases weren't found, and tests were skipped
      with a warning, which lead to 1.4.0 being released with two failing testcase.
      Fix to find the files, and make not finding them an error.

    * cavern.tst: Fix testcases gpxexport and require_fail which were failing
      in 1.4.0.

    * 3dformat.htm: Document that coordinate system can be ESRI:<number>.

    Changes in 1.4.0 (2021-11-06):

    * New release series to mark that Survex now uses the new PROJ API, and
      requires PROJ >= 7.2.0.  Survex 1.2.x will continue to support PROJ < 8
      (and won't support newer PROJ versions).  Fixes #102, reported by Bas
      Couwenberg.

      Due to these changes, PROJ will now convert directly between coordinate
      systems where it knows how to, instead of always converting via WGS84.
      This means conversions may now be more accurate in some cases, and you may
      notice station coordinates changing - these should be for the better.

      Also, the vertical datum is now taken into account automatically, and
      terrain data now aligns much better vertically with surveys.  Fixes #56.

    * aven: Clicking and holding the left mouse button on the compass or clino,
      then (while still holding) clicking the right button no longer causes a
      wxWidgets assertion to fail.  Reported by echarlie.

    * img library: Rewrite certain proj strings when reading 3d files for
      better compatibility with newer PROJ versions, where use of proj
      strings is strongly discouraged.

      `+init=epsg:` followed by a code number is rewritten to `EPSG:`.

      `+init=esri:` followed by a code number is rewritten to `ESRI:`.

      The proj strings which cavern used to put in 3d files for UTM zones and
      S-MERC are rewritten to `EPSG:` follow by the appropriate code number.

    * Also install survex.lang for gtksourceview 4. Fixes #125, reported by Martin
      Green.

    * Fix missing data style in interleaved example in manual.  Reported by
      echarlie.

    * Use jw from docbook-utils instead of sgmltools-lite to process the manual.
      The sgmltools-lite homepage says it's no longer being developed, and suggests
      docbook-tools (which Debian packages as docbook-utils) as a replacement.

    * doc/HACKING.htm: Update Debian packages to install

    * doc/HACKING.htm: Update details of setting up mingw cross-build environment.

    * Add simple tests for GPX and KML export.

    * Expand cavern testcase csbad.

    * cavern.tst: Parse warning/error counts more robustly.  Previously we'd get
      confused if the final line just contained an integer, e.g. if we end listing
      stations not attached to a fixed point.

    Changes in 1.2.45 (2021-03-09):

    * Avoid undefined signed shifts in 3d file handling.  Survex itself is only
      affected on big-endian platforms (so most Linux machine, Microsoft Windows,
      and current Macs are all OK), but this also affects the img library on all
      platforms when used in standalone mode as it is in other programs.  Fixes
      #119, reported by Matěj Plch.

    * aven:

      + When reading cavern output for the log window, we need special handling
        for the case when a chunk of output ends mid-way through a UTF-8
        sequence.  Previously we lost the first byte of the sequence in this
        case (and would then show it as an invalid character), but now it is
        handled correctly.  In practice, most of the cavern log output is ASCII so
        it's quite possible nobody's ever actually hit this.

    * testsuite:

      + Suppress reports of leaks on exit from the LeakSanitiser debugging tool.
        We know we don't release all memory explicitly on exit since doing so would
        mean extra work for no reason as the OS reclaims all memory when the
        process exits.

    * Convert OLDNEWS encoding from ISO-8859-1 to UTF-8.

    Changes in 1.2.44 (2021-02-10):

    * aven:

      + (Microsoft Windows version): Now using wxWidgets 3.0.5 (was 3.0.4).

    * cavern:

      * Add support for quadrant bearings (e.g. N30E).  Patch from echarlie.

      * Report error if angle units are specified for passage dimension.
        Previously "*units left degrees" and similar were incorrectly quietly
        accepted.  Spotted by echarlie.

      * Fix *data with no parameters to keep the current style and reset any state
        as documented.  Previously it actually instead ignored any survey data
        until the next *data command with parameters.

      * Fix minor memory leak in *data.  We leaked a single memory allocation on
        "*data default" or an invalid *data command.

      * Improve test coverage.

    * survexport:

      * The check for whether a format supported --elevation, --plan, --bearing and
        --tilt was inverted.  Reported by echarlie.

      * Fix reporting of export errors on Microsoft Windows.  Reported by Matic Di
        Batista.

    * img library: Fix img_open() when used in other programs.  Patch from Thomas
      Holder.

    * configure: Add wx-config-gtk3 to WX_CONFIG search for Arch Linux.  Patch
      from Thomas Holder.

    * Improve documentation of interleaved data.  Most notably, we now document
      that a blank line breaks the current traverse.

    * Fix typo in manual ('cypolar' -> 'cylpolar').  Patch from Wookey, fixes #117.

    * Chinese translation updates from Qingqing Li.

    * Russian translation updates from Vasily Vl. Suhachev.

    * French translation updates from Jean-Marc and from Wassil Janssen.

    * Bulgarian translation updates from Wassil Janssen

    Changes in 1.2.43 (2020-02-28):

    * cavern: Update to use v13 of the IGRF model for calculating declinations.
      This was issued in December 2019 and should give slightly more accurate
      declinations for surveys made since 2010.

    * aven:

      + Fix colouring of "not in loop" when colouring by error.  1.2.42 introduced
        a bug where surveys not in a loop were coloured as if they had zero error.
        Fixes #111, reported by Bruce Mutton.

      + Fix handling of grid in export.  The grid was always getting enabled
        (probably since 1.2.8) even for formats which don't support exporting with
        a grid.  This resulted in the bounding box being set wrongly for some
        formats such as SVG, as reported by Richard Knapp on the mailing list.

      + When showing errors processing the survey data we'd previously crash if
        cavern incorrectly reported an error as being in a column off the end of
        the line - now we just ignore the error column in this case.

      + Support colouring by survey style ("normal", "diving", "nosurvey", etc).

    Changes in 1.2.42 (2019-09-04):

    * aven:

      + Allow colouring by horizontal or vertical error.

      + (Unix version): Disable scaling for HiDPI displays with GTK3.  The OpenGL
        code needs work before this will work usefully, so just disable for now
        (which simulates how things are when using GTK2).

      + (Unix version): Fix orientation of notebook tabs when build with wxWidgets
        3.1 development versions.  We want horizontal tab orientation, but were
        passing a weird flag combination which now results in vertical tab
        orientation.

    * When exporting to a format where we support rotation in the horizontal
      plane (such as SVG), the rotation was incorrectly applied to cross section
      data (except for the default rotation of zero).  Fixes #108, reported by
      Richard Knapp.

    * Add a section to the manual covering the command line tools, and what you
      might still need to use them for.

    * Fix compiler warning when building from source with GCC 9.

    * Consistently refer to macOS not OS X - Apple have renamed it yet again.

    * (macOS version): Revert the workaround for the crash on macOS 10.14.  The
      bug we were working around is fixed in git ready for wxWidgets 3.0.5 and
      there's a backported fix in the homebrew wxmac 3.0.4-2 package, which is how
      we now recommend people install on a Mac.  Closes #101, reported by floho.

    * (macOS version): Remove buildmacosx.sh script since installing from homebrew
      is now the recommended approach.

    Changes in 1.2.41 (2019-07-10):

    * aven:

      + (Microsoft Windows version): Fix error on startup in the pre-built version
        of 1.2.39 and 1.2.40.  This is a recurrence of the same issue as affected
        1.2.33 - this time I've patched out the unnecessary check in wxWidgets
        which causes this problem so it shouldn't recur again.  Reported by
        Brian Clipstone.

      + (macOS version): Add work around for crash on macOS 10.14 (not fully tested
        as I don't have access to a Mac).  Hopefully fixed #101, reported by floho.

    Changes in 1.2.40 (2019-07-04):

    * aven: Draw the measuring line ring with an even shape.  Previously the exact
      shape of the ring varied slightly depending on the exact coordinates, which
      could be visually distracting once you noticed it.

    * We were casting a function pointer with a bool return type to the same type
      but with a void return type.  In practice this probably works fine on most
      platforms, but it's undefined behaviour and also gives a compiler warning
      with some compilers.

    * Fix bug introduce in 1.2.39 with where the "esri" data file for PROJ is
      installed.

    Changes in 1.2.39 (2019-06-29):

    * Support versions 5.x and 6.x of the PROJ library we use for handling
      conversions between coordinate systems.  Reported by Bas Couwenberg
      in #102, by Richard Knapp in #103 and by Martin Sluka in email.

    * (Unix and Mac OS versions): When checking if something is a file or if it is
      a directory, we no longer treat a symlink as being neither, but instead
      return an answer based on what the symlink points to.

    * aven:

      + Improve handling of hidden splay ends.  Previously, hidden splay ends still
        served as "targets" for snapping the mouse pointer to, and still got
        crosses when crosses were enabled.  We don't have a handy flag for "this is
        the outer end of a splay" and computing that on demand isn't so easy to do,
        so for now we use the "anonymous station" flag so at least these cases now
        behave properly for splays to anonymous stations (which is likely to be
        what people with huge numbers of splays from disto-x, etc are using).  This
        does mean that anonymous stations on continuation passages will incorrectly
        also be off when splays are hidden, but that seems an OK trade-off for now
        and a definite improvement over the previous situation.  The snapping of
        the mouse pointer was reported by Frank Tully in #105.

      + Fix typo in export UI (CVS should be CSV).

    * Documentation:

      + Add CSV to documented list of survexport output formats.

      + Fix *declination syntax synopsis - "auto" is a literal string, not a
        placeholder.

      + Update PROJ project name and website - the name is now "PROJ" (all caps and
        no ".4" suffix) and the website is now: https://proj.org/

    * Install gtksourceview-3.0 language file so .svx files now get syntax
      highlighting in gedit and other GtkSourceView-based editors.  Patch
      from Philip Withnall.  Fixes #98.

    * (Microsoft Windows version): The Survex installer doesn't uninstall the old
      version when you upgrade, but just overwrites it with the new version.  In
      1.2.35 cad3d.exe was replaced with survexport.exe, but a user upgrading from
      an older version would still have cad3d.exe from that old version.  We now
      remove any old cad3d.exe left over from a previous install in the same
      location to avoid confusion.

    * Add a few more message translations.

    * Fix warnings when built with a C++11 compiler.

    Changes in 1.2.38 (2019-03-02):

    * cavern:

      + Deprecate MILS as angular units.  Survex has long support MILS as an alias
        for GRADS.  However, this seems to be a bogus definition of a "mil" which
        is unique to Survex (except that Therion has since copied it) - there are
        several different definitions of a "mil" but they vary from 6000 to 6400 in
        a full circle, not 400.  Reported by Andy Edwards.

      + Fix segfault for *include "".  This isn't useful, but shouldn't crash.  It
        now reports "file not found" instead.

      + Use isnan() to check for not-a-number.  This is cleaner, more robust and
        more efficient than formatting the number as a string and checking for
        "NaN" or "nan" in the result.

    * Avoid unused variable warning when compiling from source with modern ffmpeg.

    * Drop support for wxWidgets < 3.0.  3.0.0 was released over 5 years ago and
      should be easily available everywhere by now.  I'm no longer easily able to
      test with wxWidgets 2.8, and this allows a significant amount of cruft to be
      removed.

    * (Linux version): survex.spec: Fedora have removed gcc from the default build
      environment so need to explicitly list it in the BuildRequires tag.  See
      https://fedoraproject.org/wiki/Changes/Remove_GCC_from_BuildRoot for more
      information.  Patch from James Begley.

    Changes in 1.2.37 (2018-11-18):

    * aven:

      + Add basic "Colour by Survey" feature.  The colours used aren't currently
        controllable.

      + Fix export of splays.  Patch from Thomas Holder.

      + Fix KML export to avoid invalid geometry when a tube intersects itself.
        Patch from Robert Jones.

      + (Unix version): Fix to work under Wayland by forcing the x11 GDK backend
        for now.  This is a workaround until wxWidgets OpenGL support is updated
        to work under Wayland.  Reported by Philip Balister.

      + Fix warnings about using deprecated functions when building movie export
        code using FFmpeg 4.0.

    * cavern:

      + Compass MAK files: Handle fixed point coordinates in feet - previously the
        units were ignored and the coordinates assumed to be in metres.

      + Previously the first byte in a MAK file was ignored.  Typically MAK files
        start with a comment, and since cavern currently ignores lines that start
        with characters it doesn't understand the meaning of, this bug would often
        go unnoticed.

    * survexport:

      + Fix exporting of passages, walls and cross-sections by running the code
        aven uses to decide how much to rotate each cross-section.  Previously all
        cross-sections were aligned West-East.  Reported by Robert Jones.

      + Default to .pos output if the program name is 3dtopos, and install a second
        copy (or hardlink under Unix) as 3dtopos.  This provides compatibility with
        current releases of Tunnel.  Reported by Becka Lawson, Wookey and
        Stephen Crabtree.

    * Fix some German translations.  Patch from Thomas Holder.

    * (MacOS X version): Fix aven-create-app to not delete converted icons.
      Typo spotted by Robert Jones.

    * Improve documentation for *team.  Document the requirement to quote names
      unless a person is identified by just one name.  Document that the roles are
      optional, as that information may not have been recorded, and to align with
      therion's team command.

    Changes in 1.2.36 (2018-07-18):

    * aven:

      + Add support for exporting as a CSV (Comma-Separated Values) file.

      + Support exporting KML with altitude mode "clamp to ground".  In this mode,
        the altitude in the data is ignored and it's rendered on the surface of the
        terrain.  This is useful if your KML viewer renders the terrain as opaque
        so underground data isn't visible.  Rendering cave passages on the surface
        isn't great, but is better than not being able to see them at all.  This
        option may also be helpful if you want to see where to look on the surface
        for new entrances.

      + Highlight surveys with a white loop as the mouse is moved over them in
        the survey tree.  This is akin to how we highlight a station with a
        white ring, and allows restoring "double-click survey in tree to zoom"
        which temporarily required a quadruple-click in 1.2.35.

      + Only show checkboxes in the survey tree for surveys not stations.

      + Fix wxWidgets assertion if the user tried to select additional surveys
        to show via the right-click menu.

      + Fix multiple survey filtering when both a parent and child survey are
        selected.  In this case it makes most sense to show all child surveys of
        the parent, but we actually showed a slightly arbitrary subset of the
        child surveys of the parent.

      + The checkbox area in the survey tree is now included in the area which
        is considered by mouse-over updates such as highlighting the station or
        survey.

      + Fix display of double quotes in cavern log window (they were being replaced
        with control character 0x16 due to a typo in the code).

      + Add shortcuts to buttons in cavern log window.

      + Eliminate use of gluErrorString() function which eliminates some
        deprecation warnings when building on macOS.

      + Reject multiple --survey command line options for now (only the last has
        been used for a long time, but now we actually support multiple survey
        filtering this matters more).

    * survexport:

      + Report a useful error when trying to convert a .3d file without coordinate
        system information to GPS.  Reported by Mark Shinwell.

      + Handle multiple redundant --survey command line options correctly.

    * dump3d: Report station flag "WALL", which was added in 1.2.7.

    * Minor translation updates.

    * Update manual for Microsoft Windows changes.

    * tests/: Add test coverage for warnings about suspect readings

    * Fix warning when compiling with clang.

    Changes in 1.2.35 (2018-07-03):

    * aven:

      + Viewing can now be restricted to multiple surveys.  Use the right-button
        menu on a survey in the survey tree and select "Show" to enable checkboxes
        for that survey and all its siblings.  Only the selected surveys are shown
        on screen, printed and exported.

      + Don't open a survey when its name is double clicked.  This was happening
        due to code added to "allow double-clicking to work on wxMSW >= 2.8.11".
        However, reverting that change still seems to allow double-clicking to work
        on both wxMSW and wxGTK, but fixes the unwanted additional opening of the
        survey.

      + Pick initial survey scaling based on whichever of the window width or
        height gives the smaller scale.  Previously we always used the window
        width, which can result in parts of the cave being outside the initial
        view.  Reported by Wookey.

      + Drop ability to specify a PROJ string in the export dialog.  This was added
        to allow exporting to formats such as GPX before we added support for
        specifying the projection in .svx files, and that support is now mature.

      + DXF export now uses 2 decimal places (was 6) for the bounding box, for
        consistency with the precision used for coordinates.

      + Fix handling of surface flag during export.  In formats which discriminate,
        legs could previously have got assigned the wrong status.

      + Fix bug which probably prevented aven starting when OpenGL double buffering
        is unavailable.  This is unlikely to affect any common configurations.

      + (Microsoft Windows version): Fix loading of 3d files with non-ASCII
        filenames.  Issue reported by Matic.

      + (Microsoft Windows version): Fix incorrect display of some toolbar icons.
        Probably broken since 1.2.17.

    * survexport: New command-line export program which uses aven's export code.
      Replaces 3dtopos, cad3d and findentrances, since it can do all that these
      tools could do, plus much more.

    * Merge more Spanish i18n updates from Evaristo Quiroga.

    * Minor updates to various other translations.

    * img library:

      + Now supports reading from and writing to an existing FILE*.

      + Improve API documentation.

    * (Microsoft Windows version): Fix packaging to include wxWidgets translation
      files like it was supposed to, which fixes a few missing translations.  This
      was probably broken by changes in 1.2.8.  Reported by Evaristo Quiroga.

    * (Microsoft Windows version): Drop two options from explorer bindings.
      "Convert to DXF" and "Convert for hand plotting" have both been supported via
      aven for a while, and that's a more useful way to access them as you can
      control what gets exported.

    Changes in 1.2.34 (2018-03-24):

    * aven:

      + (Microsoft Windows version): Fix error on startup in the pre-built version
        of 1.2.33.

      + (Microsoft Windows version): Now using wxWidgets 3.0.4 (was 3.0.2).

    Changes in 1.2.33 (2018-03-22):

    * aven:

      + Reliably disable scale bar in perspective view.  This is supposed to happen
        (because the scale across the screen varies in perspective view) but
        actually the scale bar stayed around until an update was forced for another
        reason.  Spotted thanks to Pedro Silva Pinto.

      + Make "no date"/"not in loop" colour grey.  The white was a bit bright and
        made it harder to see the legs that had colours.  The grey now used is
        within the brightness range of the other colours.  Fixes #94, reported by
        Erin Lynch.

      + Fix KML export - exporting both survey legs and station names resulted in a
        malformed KML file.  This bug was introduced in 1.2.30 when support for
        exporting passages and walls was added.  Reported by Erin Lynch in #90.

      + Consistently use 2 decimal places for altitude in KML output.  Some places
        used 8 decimal places which is appropriate for lat and long, but clearly
        overkill for an altitude in metres and increases the file size
        unnecessarily.

      + Right-align bearing widget in print/export dialog.  The change to allow the
        value to wrap round from 360 to 0 in 1.2.27 inadvertently made this control
        left-aligned (due to incorrect wxWidgets documentation of the default style
        for this control).

      + (Unix version): Work around wxWidgets bug so that custom cursors work
        under GTK3.

      + (Unix version): Update GTK version reporting - report GTK3, and don't
        bother to report subversions of GTK2 (it seems to be fairly arbitrary
        which subversions wxWidgets defines constants for).

      + Update code to work without warnings when using wxWidgets 3.1.0 (the
        current development version).

      + Make movie export code compatible with upcoming FFmpeg 3.5 release.
        It should still work with the older versions that worked before this
        change.  Reported by James Cowgill in https://bugs.debian.org/888334

    * cavern:

      + Warn about 2 digit years.  We can't change the assumption that these are
        19xx without risking breaking existing datasets, but the further we get
        into this century, the more likely such an assumption is to catch someone
        out.  The warning can easily be quashed by explicitly adding the assumed
        "19".

    * The Spanish translation is now up to date once more, thanks to updates from
      Evaristo Quiroga.

    * Merge French translation updates from Jean-Marc.

    * Fix transposed German Northing and Easting labels.  Fixes #95, reported by
      milosch.

    * Fill in missing translations of "Easting", "Northing", "E" and "N" for
      Bulgarian, Greek, Hungarian, Polish and Russian based on other existing
      translated messages.

    * Align .pos file headings better with columns of coordinates below for
      Indonesian and Polish.

    * Fix handling of the message string "error" before messages loaded.  If
      there's an error loading messages, we need this message to report it.
      Reported by Martin Sluka.

    * Fix a few compiler warnings.

    * img library: Fix extracting leaf survey name for survey title.  When there
      are three or more levels of survey, we were taking everything after the first
      dot rather than everything after the last dot.

    * Fix problems with testsuite on macOS:

      + cavern.tst: Skip "ONELEG" testcase on case-insensitive filing systems
        - this test isn't meaningful unless the filing system is case-sensitive,
        but happens to fail if it isn't.

      + cavern.tst: Workaround limitations of Apple's sed.

      + aven.tst: Fix not to hang on macOS.

      + smoke.tst: Remove aven testcases which duplicate those in aven.tst.

    * Clean up handling of support files in relocatable installs - this is now
      detected at run time on macOS.

    * Split out macOS Aven.app creation into a make rule so it can be easily used
      by the homebrew formula.

    * buildmacosx.sh:

      + Fix when WX_CONFIG not specified - this was giving a confusing error like:
        ./buildmacosx.sh: line 163: --cc: command not found

      + Use wxWidgets 3.0.4.

    * Stop checking wx-config --ldflags as this option was removed in wxWidgets 2.6
      and we currently require 2.8 or newer.

    Changes in 1.2.32 (2017-07-08):

    * aven:

      + Make splays on printouts a darker shade of grey.  Reported by Erin Lynch
        and Anthony Day.

      + In export formats which include 3 dimensions (DXF, PLT, GPX, KML, JSON,
        POS), the value in the Z dimension was negated.  Bug introduced by fixes
        for export of rotated plans and tilted elevations in 1.2.27.  Reported by
        Erin Lynch in #89.

      + Ignore viewing angles for export formats which work in 3D.  When the
        rotation and tilt controls are hidden in the export dialog we were still
        using their values to transform the data, so if you set them with for one
        export format which support them, then switched to an export format which
        doesn't, you'd get bogus coordinates in the exported file.  Bug probably
        introduced in 1.2.27 by fixes for exports of rotated plans and tilted
        elevations.

      + Fix exporting to skencil and Survex .pos formats.  When aven's export to
        .pos was added in 1.2.19, the ordering didn't match up and since then .pos
        export has produced skencil files and vice versa.

      + Don't leave terrain on if loading terrain data fails.  Previously if you
        clicked the terrain icon (or via the menu) with no terrain loaded, but no
        terrain got loaded (e.g. because the survey data lacks an explicit
        coordinate system, or because the file failed to load, or because you
        cancelled the dialog) then the terrain icon/menu item was still changed to
        "on".

      + Disable texturing while drawing terrain.  Previously the terrain got a bit
        darker when "Textured Walls" were enabled.

      + Force a refresh when "Textured Walls" are enabled or disabled.  Previously
        the display wouldn't update right away.

    * Manual:

      + Document how to specify fixed point altitude in feet.

      + Explain why *fix warns about unused fixed points

    * Building from source now requires a compiler with decent support for C++11.
      If you're using GCC, then GCC 4.7 should suffice.  This should not be an
      onerous requirement - e.g. Debian wheezy and Ubuntu trusty both have a recent
      enough GCC.  If special options are needed, these should get probed for and
      automatically.  Fixes building 1.2.31 with GCC < 6, reported by Wookey.

    Changes in 1.2.31 (2017-07-01):

    * aven:

      + Use superscript 'g' symbol instead of word 'grads' in status bar.  This
        conserves the limited space available, and we already do this in the
        compass and clino indicators so it's more consistent too.

      + Show one decimal place on measure line bearing.  Pointed out by Benedikt
        Hallinger on the therion list, though I'm sure this has been asked for
        before by others.

      + Show gradient of the measuring line when both ends are stations.

      + Allow selection of text in cavern log window.  Selection was disabled in
        1.2.28 because it seemed you couldn't actually copy selected text to the
        clipboard, but retesting this now actually works fine for me, both with
        current git master with the change reverted, and with code just before the
        original change.

      + More robust parsing of cavern output (cleanly handle context highlighting
        which extends beyond the end of the line).

      + Allow showing duplicate legs as dashed lines or hiding them entirely,
        with dashed now being the default.  Implemented by Patrick Warren.

      + Also allow "Dashed" for splays and "Faded" for duplicate legs.

      + Splay legs in surface data are also shown faded.

      + Check environment variables VISUAL and EDITOR when looking for editor to
        use when a warning or error is clicked on in the cavern log window.  The
        specified editor may have a GUI or need to run in a terminal, so we have to
        special-case each editor supported, and that means we can pass extra
        options needed to position the cursor on the appropriate line/column.
        Currently these editors are supported: gvim, nvim, vim, gedit, pluma,
        emacs, nano, jed, kate.  Suggested by Wookey.

      + Fix handling of non-square terrain data files - the X and Y dimensions were
        swapped.  Reported by detrito.

      + Improve parsing of DEM data with .hdr file.  Use documented defaults for
        more values, and where we only support a subset of values (or a particular
        value) check for unsupported values in more cases.

      + When colouring by depth, fix colouring and texturing of polygons which
        cross depth bands.  The previous problems were most obvious with high
        chambers and long legs down deep pitches, especially in for surveys without
        much vertical range.

      + Support for drawing blobs using point sprites was added in 1.2.28,
        but caching that this worked wasn't hooked up properly so the test to
        see if this worked would happen at the start of each run.  This is now
        cached as intended which should reduce start up time a little when blobs
        are drawn in this way.

      + Fix drawing of crosses with lines.  This is a fall-back case which is
        rarely used as most OpenGL setups will handle a better method, but it was
        resulting in crosses with a four-pixel square in the centre - now the
        centre should be a single pixel.

    * cavern:

      + Allow *data with no arguments to reset the current style - useful for
        entering passage data where there are side passages.

      + Fix hang processing file without newline at end.  This bug was introduced
        by changes in 1.2.28.  Reported by Mark Brown.

      + (Mac OS X and Microsoft Windows versions): Build with newer version of
        PROJ library which fixes buggy handling of *fix with lat-long coordinates.
        Also add a testcase to the testsuite to alert users building for themselves
        with an affected PROJ version on any platform.  Reported by Ross Davidson.

      + Fix cavern to handle Compass .DAT with no survey team.  Previously this
        resulted in the bogus error: Expecting numeric field, found "FROM"
        Reported by Erin Lynch.

      + Handle UTF-8 "BOM" at start of .svx files.  Unicode doesn't recommend its
        use, but Microsoft stuff seems to like to create files with it in, and the
        error cavern currently reports for such files is very confusing, so it
        seems best to just handle it.  Reported by Rob Eavis.

      + Change a couple of messages to use double quotes for consistency with all
        other messages.

    * extend:

      + Now runs a bit faster.

      + Splays are now carried over the extended survey.  The current handling
        is simplistic, but should do a good enough job to be more useful than
        discarding splays.  The splays at each station are all rotated together
        based on the bearing between the stations either side of the current one
        along the first path extended through that station.  This nicely handles
        dead ends and the situation at the top or bottom of a pitch, and should
        tend to pick an angle close to the passage orientation along a traverse.
        It's weakest at junctions.  Feedback (especially examples which could
        be handled better) most welcome.

    * French translation is now up to date again, thanks to Jean-Marc.

    * Remove erroneous menu shortcut markers from Polish translations.

    * Fill in some missing translations in several languages by using message
      translations from therion.

    * Add note to *fix documentation to clarify the coordinate order with *cs
      long-lat.  Issue raised by Ross Davidson.

    * Fix errors in documentation of *units: "DEG" should be "DEGS", and
      "MINUTES" has been supported for ages but wasn't documented.  Reported by
      Footleg.

    * Fix a few typos in the documentation.

    * Fix compilation warning with recent GCC.

    Changes in 1.2.30 (2016-10-03):

    * aven:

      + (Microsoft Windows version): Fix crash when trying to print or export
        (probably introduced in 1.2.28).  Reported by Brian Clipstone.

      + Report error if terrain file contains no terrain data in area of survey.
        Suggested by detrito.

      + Errors when writing an export file were reported with the wrong filename
        - the .3d file, not the filename we were trying to write to.

      + Export to KML now supports exporting passages, walls and cross-sections.
        Addresses the remainder of ticket #4.

    * Add man page for dump3d.

    Changes in 1.2.29 (2016-09-27):

    * aven:

      + Fix SVG output with non-ASCII characters (the charset in the SVG file
        is now set to UTF-8 not ISO-8859-1).

      + (Microsoft Windows version): Fix error dialog on startup in pre-built
        version.  Reported by Brian Clipstone.

    * Manual: Add link to TerrainData wiki page.  Omission highlighted by Erin
      Lynch and "detrito".

    * Fix to build without FFmpeg/libav and with older versions, broken by changes
      in 1.2.28.  Reported by James Begley.

    Changes in 1.2.28 (2016-09-24):

    * cavern:

      + Show the contents of the line after error and warning messages while
        processing survey data, and indicate the region of the line in many cases
        in the same style that compilers such as GCC and clang use (using the
        column number we already have, plus new width information).  Based on a
        patch from Mateusz Golicz.

      + Add column and width information for many more error and warning messages.

      + Fix column for "Separator in survey name" warning.

      + Improve warnings when using a backclino with range 0-180 degrees (reusing
        the same machinery we already have for a forward clino with range 0-180
        degrees).

    * aven:

      + Include LRUD in printout/export of extended elevations, broken by
        improvements to export of tilted elevations in 1.2.27.  Reported by Anthony
        Day.

      + Name <trk> tags in GPX output, so Garmin GPS units name the imported track
        usefully.  Reported by Anthony Day.

      + Remember scale from previous print or export operation in the same run of
        aven.  Suggested by Stuart Bennett.

      + Convert range indication below shown line to a highlight on that region
        of the line in cavern log window.

      + Fix colouring of error/warning without column in cavern log window.

      + Fix click on error/warning without column in cavern log window.

      + Fix highlight of translations of "error" or "warning" containing non-ASCII
        characters.  This fix for this only works with a Unicode build of
        wxWidgets, but as of wxWidgets 3.0, all builds are Unicode, so this
        shouldn't be much of a problem as wxWidgets 2.x is close to obsolete now.
        Reported by Mateusz Golicz.

      + Disable selection of text in cavern log window - you can't currently copy
        it to the clipboard, so until that's implemented it seems better to disable
        the ability to select it.  Reported by Wookey.

      + Avoid special "1000" scale entry when exporting.

      + Show 1 page when "One Page" selected.

      + Reload processed data when restricting view.  Fixes failure when
        restricting view on data just processed via aven.  Spotted by Andrew
        Atkinson and myself.

      + Don't hide blobs and crosses behind terrain.  Reported by Jenny Black.

      + Fix rendering of crosses using point sprites.  The texture being used was
        misaligned relative to the image used for the visual fidelity check, so the
        check always failed and point sprites would never be used.  Where point
        sprites are supported, they're probably the fastest option - on my netbook
        this change improves FPS by ~6 fold when displaying crosses for a large
        survey.

      + Support drawing blobs using point sprites.  About 5 times faster than using
        lines on my netbook.

      + Recheck how best to draw crosses and blobs on the first run after Survex
        is upgraded (or downgraded) as the rendering code may have changed (we
        already recheck when the OpenGL hardware or driver changes).

      + Change "MPEG" export to be MPEG4 (.mp4) rather than MPEG1 (.mpg).
        MPEG4 produces smaller output of higher quality, and should be widely
        supported these days.  And I can't get the MPEG1 output to work without
        buffer underflows, resulting in a file which doesn't play without
        glitches.

      + Add OGG video to the list of formats - it's more compact than the others
        we currently list, though slower to write.

      + Fix export to movie formats for which libav/FFmpeg needs to seek the file
        being written.  This was broken by changes in 1.2.27.

      + Overhaul movie export for the current FFmpeg API, fixing deprecation
        warnings when building against a recent version.

      + (Microsoft Windows version): Fix corrupted exported movie files.  1.2.27
        changed the movie export code to allow writing to files with non-ASCII
        characters in the names, but the new code failed to open the file in binary
        mode, leading to corrupt output.  Fixes #81, reported by Erin Lynch.

      * (Microsoft Windows version): Pre-built version now uses FFmpeg 3.1.3 for
        movie export.

      * (Mac OS X version): Pre-built version now uses FFmpeg 3.1.3 for movie
        export.

    * Fix to build without FFmpeg/libav, broken by changes in 1.2.27.  Reported by
      James Begley.

    * The Polish translation is now very close to being complete, thanks to a
      substantial update from Mateusz Golicz.

    * Merge catalan translation updates from Adolfo Jayme.

    * (Microsoft Windows version): Map LANG_CHINESE to zh_CN not zh so Chinese
      messages get used automatically.

    * cavern.tst: Remove random : from after ] - dash ignores the extra character,
      but it causes this test to fail if /bin/sh is a different shell (e.g. bash).

    * cavern.tst: Add expected output for more testcases.

    * Remove unwanted execute bit from some testcase data.

    * Use https for more URLs which support it.

    Changes in 1.2.27 (2016-06-06):

    * aven:

      + Right click on a survey in the survey tree now gives a pop-up menu
        with "Hide others", which restricts the view to just that survey
        and any subsurveys.  Right click on the root of the survey tree
        gives a menu with "Show all" to undo any restriction in effect.
        (Currently these are implemented by reloading the file and using
        the same machinery as the --survey= command line option, but that will
        probably change in the future).

      + If there's a sub-survey restriction (from the --survey= command line
        option or the new UI described above) it is now shown in brackets after
        the survey tree root.

      + When reloading a survey, preserve the current view position (previously
        the view was recentred).

      + When reloading a survey, actually preserve the current scale factor
        (this was meant to happen, but the adjustment was applied in the
        wrong direction).

      + New "File->Extended Elevation..." menu item provides a way to generate
        extended elevations for simple cases without having to use the command
        line.  Suggested by Fleur Loveridge.

      + Don't process key presses if accompanied by an unexpected modifier key.
        In particular, this means that aven no longer interferes with Alt+<function
        key> (which is typically handled by the desktop) and Alt+<letter> (which is
        typically a menu short cut).  Reported by Владимир Георгиев.

      + Reduce file loading time by ~5%.  The station name compare function was
        something of a hot spot, and optimising it yielded a nice improvement.

      + Allow splay legs to be disabled in when printing and exporting.  Mostly
        addresses #60.

      + SVG export now shows splay legs thinner and in grey.  See #60.

      + Fix export of rotated plans and tilted elevations - previously plans were
        always aligned with North up, and elevations which weren't exactly side on
        were exported as plans.  Reported by Stuart Bennett.

      + Fix offset bounding box for exported elevations.

      + In print/export dialog the bearing value now wraps if you scroll up past
        360 or down past 0.

      + Fix greying out of LRUD-based controls in the print/export dialog when the
        view is tilted (i.e. not plan or elevation).  This stopped working in
        1.2.18 when the pan and tilt spin controls were changed from integer- to
        real-valued ones.

      + Printouts now show LRUD as pale grey arrows from the station they are
        measured from.  Based on patch from Michael Sargent.  Closes #65.

      + Take LRUD into account for printout size.  Fixes #72, reported by Erin
        Lynch.

      + Update movie export code to work with latest version of FFmpeg.

      + Make "Show Log" a toggle, so you can click on the button to take a look at
        the log, and a second click returns you to the survey view.

      + (Microsoft Windows version): Open the font file in binary mode - it looks
        like we were lucky and the font file (or at least its current version)
        would have loaded OK in text mode despite being binary data.

      + (Microsoft Windows version): Exporting to files with non-ASCII filenames
        should now work.

    * cavern:

      + Allow tape or backtape to be omitted.  Reported by Erin Lynch.

      + Grid convergence is now corrected for when using automatically
        calculated declinations (*declination auto <X> <Y> <Z>).  Requested
        by Mateusz Golicz on the mailing list.

      + Clear any cached calculated declination upon another *declination auto
        with different coordinates.  Previously if the date stayed the same,
        a previously cached declination for the old coordinates was used.

      + Fix check for end of version number array in *require.  We would check up
        to 12 version components, the last 9 being bogus.  In practice, *require is
        only likely to be used with up to three components, so this wouldn't be an
        issue.

      + *begin with an invalid prefix could cause a crash in some cases.  Fixed
        by patch from Colin Watson.

      + Report column locations for errors to do with readings.

    * Merge translation updates from Jean-Marc.

    * img library: Better document which members can be set when writing.
      Highlighted by email query about use of img API from Владимир Георгиев.

    * Document how *declination interacts with *calibrate declination if both are
      used in the same dataset.

    * doc/3dformat.htm: Update details of how changes to the current label buffer
      are encoded to reflect changes in v8.  Reported by Angus Sawyer.

    * Use docbook2man instead of docbook-to-man to generated Unix man pages
      from SGML source.  The latter seems to be no longer actively maintained, and
      docbook2man now does a similarly good job.

    * Use https for survex.com links, and for other sites which support it.

    Changes in 1.2.26 (2016-01-07):

    * aven:

      + (Microsoft Windows version): Fix to be able to process .svx files with
        cavern again.

    * (Microsoft Windows version): Simplify upgrading process with innosetup
      installer - if Survex is already installed, we now just install to the same
      location and use the same start menu folder.

    * (Linux version): survex.spec: Update for filetype metadata change in 1.2.25.
      Fixes #79, reported by James Begley.

    * (Linux version): survex.spec: Fix to work with RPM 4.13.  Fixes #79, reported
      by James Begley.

    Changes in 1.2.25 (2016-01-05):

    * aven:

      + Drop broken code which attempts to fix 2D pitches.  Fixes #73, reported by
        Erin Lynch.  #76 tracks the issue the removed code was trying (but failing)
        to address.

      + When animating, don't try to update station info based on mouse movement
        over the survey tree.

      + Further improve code to handle cavern subprocess in aven.

      + Fix jump to error for filenames containing colons when the error location
        doesn't have a column number.  Bug noted by Jenny Black.

      + If we encounter bad UTF-8 in cavern output, replace it with a red and white
        ? in a diamond (previously we gave up showing output at the first bad
        sequence).  This can happen if you process a .svx file which isn't UTF-8
        encoded.

      + (Unix version): Don't try to set the terminal window title when opening an
        editor from the cavern log window - gnome-terminal no longer supports this,
        and there doesn't seem to be a portable option for specifying the title for
        terminals which do still support this.

      + (Microsoft Windows version): Also quote for cmd.exe so that paths with
        spaces in work reliably.  Reported by Marco Cotto.

    * cavern:

      + Improve error for mismatched fore/back-sight plumbs, reported by Andy
        Edwards (see #78).

      + Fix to use correct sd for backcompass.  We were using zero instead, the
        most obvious effect of which was that the threshold for warning about
        differing COMPASS and BACKCOMPASS was about 71% of what it should have
        been, so we were warning in more cases than we should have been.

      + Implement support for specifying a length on backsights - if you're using
        something like a disto-x, you'll get a distance reading for the backsight
        too.  Fixes #71, reported by Erin Lynch.

      + Make line counting more robust to mixed line ends.  Noticed in example file
        from Pete Smart (see #69).

    * extend: New --show-breaks option which adds a leg flagged as surface survey
      between each points at which a loop has been broken.  Suggested by Jenny
      Black.

    * (Unix version): Update filetype metadata to work with modern desktops.

    * Fix incorrect reporting of errors reading and writing processed survey data.
      Since 1.2.8, the error strings corresponding to IMG_CANTOPENOUT,
      IMG_BADFORMAT and IMG_DIRECTORY have been mixed up (this doesn't affect
      external programs using the img library, only Survex).  Reported by Jenny
      Black.

    * Add missing options to extend man page and --help output.  Noted by Jenny
      Black.

    * Document Document Ctrl+cursor keys for rotating and tilting in aven man page.

    * Fix broken SGML markup in manual.

    * Fix typo in manual reported by Jenny Black.

    * Update vim syntax file for newer commands, etc.

    * Minor translation updates.  Thanks to Piotr Strębski and Jean-Marc.

    * Fix to compile with FFmpeg 2.9.  Reported by Andreas Cadhalpun in
      https://bugs.debian.org/803863

    * Stop maintaining ChangeLog files.  They make merging patches harder, and stop
      'git cherry-pick' from working as it should.  The git repo history should be
      sufficient for complying with GPLv2 2(a).

    * (Microsoft Windows version): The installer requires admin privileges on Vista
      and later and OS versions older than Vista are past end of life, so drop code
      which tries to set up the registry differently depending if we have admin
      privileges or not.

    Changes in 1.2.24 (2015-09-23):

    * aven:

      + (Microsoft Windows version): Fix the cavern log window.  Reported by Brian
        Clipstone.

      + (Microsoft Windows version): Add workaround to avoid breakage in Therion.
        Reported by Jenny Black.

      + If wx was built with thread support, aven now runs cavern from a separate
        thread, which works much better under wxMSW (where we can't use select),
        and also seems a bit smoother on Linux.

      + Fix handling of encoding of filenames when the operating system has no
        locale installed corresponding to the language selected for Survex's
        messages.

      + Undo accidentally committed debugging code which was sending message to
        the terminal in 1.2.23.

    * (Linux version): configure now looks first for wx-config-3.0, which Fedora's
      wx3 packages have.  Reported by James Begley.

    * Indonesian translation fully up to date again.

    * Manual: Document anonymous stations, based on the text from NEWS.  Reported
      by Wookey.

    Changes in 1.2.23 (2015-09-06):

    * aven:

      + Updating the cavern log window is now much smoother, especially on slower
        machines.

      + Show "busy" mouse cursor while processing survey data.

      + Fix an assertion if you try to start processing a survex file while one is
        already being processed.

      + Processing a .svx file with an error now still adds it to the file history.
        Reported by Martin Green.

      + Fix the orientation of the starting end of tubes.

    * cavern:

      + New *ref command to allow specifying an external reference (e.g. where to
        find the original survey notes).

      + Drop support for showing percentage progress in cavern.  It's confusing in
        a multiple-file dataset as it shows progress in the current file so jumps
        around.  It also slows down processing, and on a slow machine you'd don't
        want that, while on a fast machine processing isn't slow enough for the
        progress display to be useful.

    * French translation is now completely up to date, thanks to Michel Bovey.

    * Bundle proj's EPSG and ESRI code lists in the installers for MS Windows and
      OS X so that things like "*cs EPSG:29903" work.  Reported by Graham Mullan.

    * (Microsoft Windows version): Process survey data with aven rather than
      running cavern.

    * (Microsoft Windows version): Installer built with InnoSetup 5.5.6 (recent
      releases have been built with 5.5.3) to see if that solves Ray Duffy's
      reported issue with not having file associations for .svx files created.

    Changes in 1.2.22 (2015-08-17):

    * aven:

      + Ensure that the window has a depth buffer.  Whether it does by default
        seems to vary depending on OS and maybe graphics card.  Fixes #55 (terrain
        is no longer visible through itself), and also the rendering of passage
        tubes.  Thanks to Martin Green for pointing me in the right direction for
        finding this fix.

    * cavern:

      + Fix *declination with an angle to actually work.

      + Fix assertion if we try to identify a hanging survey by an anonymous
        station.

      + Improve errors for invalid survey names in *begin, *end, *equate and
        *export.

    Changes in 1.2.21 (2015-07-28):

    * aven:

      + Fix exporting to KML and other text-based formats to always use "." for the
        decimal separator - previously "," would be used when the user's locale
        specified this for the decimal separator.  Reported by Jan Schorn.

      + Implement exporting of survey legs in KML format.

      + Put "paddle" placemarker icons on stations in exported KML files, using the
        same colour coding for entrances, fixed points and exported points as aven
        does.

      + Remove the "Coordinate projection" field from the print dialog, as it isn't
        relevant there.  Reported by Wookey.

      + Fix the initial scale for small caves (since 1.2.18 the initial scale has
        been too small).  Reported by Wookey.

      + Don't rescale if the same file is reloaded, but adjust the volume diameter
        as appropriate.

      + Use wxGetenv() to read the SURVEXEDITOR variable, so we can accept Unicode
        values on Windows.

    * cavern:

      + Fix coordinate systems using latitude and longitude - PROJ.4 wants these in
        radians, but we were passing degrees, which would generally cause the
        conversion to the output coordinate system to fail.  Reported by Wookey.

      + Fix *fix with standard deviations when *cs is in use, give an error for use
        of *fix with standard deviations before *cs.

      + Add new *declination command with support for setting the declination
        automatically from the IGRF model based on the survey date.  Thanks to the
        Therion developers for the IGRF support code, which we're reusing.
        Fixes #54, reported by Wookey.

      + Allow the units for the zero error to be specified, making it easier to
        specify calibration with a scale if you measure the zero error externally
        (rather than using the instrument itself).  Fixes #61, reported by Andrew
        Atkinson.

      + Report the error from PROJ when coordinate conversion fails as part of the
        actual error rather than on a separate line.

      + Fix use after free after *solve.  This only occurs if a leg between the two
        exact same stations appears right before and right after the *solve, which
        is unlikely in real data, but the testsuite has an instance of this.  This
        was introduced by the repeat leg averaging added in 1.2.17.

      + Fix small memory leak when solving network.  This doesn't really matter
        when solving at the end of processing as cavern will exit after that, but
        if *solve is used we continue processing after solving.

    * Remove compatibility handling for specifying a country variant of a language
      in SURVEXLANG using "-" with a lower case country code (e.g. "en-us") - we
      changed to the standard "en_US" way back in 2001.  This code was mangling
      character sets with a "-" in, and is no longer useful.

    * Ignore any "@<something>" modifier in the language code.

    * Improve documentation of magnetic declination handling, and cover the new
      "*DECLINATION" command.

    * Document aven's command line options in the manual and its man page.
      Reported by Jenny Black.

    * Point to '*case' and '*truncate' from the 'SEE ALSO' sections of each other's
      documentation.

    * Remove references to SpeleoGen from the documentation - it hasn't been
      updated for many years, and can't read recent versions of the .3d format.

    * Strip documentation references to obsolete versions of MS Windows.

    * doc/HACKING.htm: Update list of debian packages to install to build from git.

    Changes in 1.2.20 (2015-06-26):

    * aven:

      + When printing, use the top margin rather than the right margin to calculate
        the height of the printable area.  In practice, the two values seem to be
        the same or very similar by default.

      + Avoid assertion if the about dialog image fails to load.  Reported by Phil
        Maynard.

      + Optimise the size of the about dialog images.

      + Add support for reading terrain data which isn't in a .zip file.

      + Force a refresh after loading terrain data so that it gets displayed right
        away.

      + Make checks for terrain data extensions in zip files case insensitive.

      + If reading terrain data fails, always report an error and never try to
        display it.

    * cavern: Allow clino readings in diving style data, suggested by Andrew
      Atkinson.  Currently these readings are ignored, but a future version will
      check that they're consistent with the angle given by the depth gauge and
      tape, and perform suitable averaging.

    * Remove lingering traces of svxedit.

    * configure: Fix to allow compiling without libav/ffmpeg, as was possible
      before 1.2.19.

    * (Unix version): Install the filetype and aven application icons under
      /usr/share/icons/hicolor, which is where they're expected to be these days.

    * (Unix version): Add %f to Exec in survex-aven.desktop.

    * (Mac OS X version): Remove useless extra copy of about box images from OS X
      disk image.

    * (Mac OS X version): Only ship one copy of each of the translations.

    * (Mac OS X version): Reduce the size of the aven binary by disabling a load of
      libav features we don't use.

    * (Microsoft Windows version): Reduce the size of the aven binary by disabling
      a load of libav features we don't use.

    * (Microsoft Windows version): Update message files to fix a missing Chinese
      message in the installer.

    Changes in 1.2.19 (2015-06-18):

    * aven:

      + Fix exporting to GPX, KML and HPGL, which all failed to write the header to
        the exported file in 1.2.18.

      + Add exporting to Survex .pos format.

      + If the measuring line isn't currently active, pressing "Escape" will now
        exit full screen mode.

      + (Mac OS X version): Change the shortcut for full screen mode to be the
        standard Ctrl+Command+F (rather than Shift+Command+F which we have been
        using since 1.2.7).

      + (Mac OS X version): When we centre the view on the station this can
        generate a mouse move event, so clear the variable which says we are
        dragging before we process a left click on a station.  This avoids random
        rotations of the survey when clicking on a station, reported in #47 by Hugh
        St. Lawrence.

      + (Mac OS X version): Force use of a non-native toolbar to stop the toolbar
        icons from being rescaled and looking fuzzy.

      + (Mac OS X version): Remove code added in 1.2.18 which tries to set stop the
        toolbar icons from being rescaled, but which requires an unreleased version
        of wxWidgets, had a typo in, and doesn't actually seem to work anyway.

      + (Mac OS X version): Drop out of full screen mode if the mouse is mode to
        the top of the screen, since we can't seem to display the menu bar in this
        case like we do on other platforms.

      + (Mac OS X version): Enable aven's movie export feature.

      + (Mac OS X version): Enable wxDisplay when building wxWidgets to better
        support multi-monitor setups.

      + (Mac OS X version): Silence warning visible when aven is run from a
        terminal about a missing CFBundleTypeRole.

      + When reading terrain data from a .zip file, report an error if the .zip
        file is bad, or if it doesn't contain any terrain data we recognise.

      + Tweak error message in terrain reading code to distinguish two failure
        cases.

      + Add viewing angles and scale to footer, and shorten some of the other items
        to make room for this extra information.  (Fixes ticket #52, reported by
        Erin Lynch)

      + If the footer is wider than the printout width, scale down the font used
        so that it exactly fits; if the footer is narrower, than space out the
        items in in so it uses the full width.

      + If the saved size for aven's window exceeds the current display size
        (mostly likely because we're now plugged into a smaller monitor), then
        reduce the size of the window to fit the display.  If the saved size is <
        (480x320), increase it to at least that, as aven isn't usable in a smaller
        window.

      + Remove crude bodge which tries to pick a nicer initial window size when
        using wxWidgets without wxDisplay on a multi-monitor setup - aven now opens
        with the same size window it had when it was closed, so the initial size is
        only relevant on the first ever run.

    * Assorted translation updates.  Notably Indonesian is at 100% again.

    * Stop trying to catch and report signals.  The only real reason to do it is so
      we can say "Bug in program detected! Please report this to the authors"
      before we exit, but when the program crashes that's pretty obvious.  In aven
      we try to pop up a message box for this message, which may fail due to
      whatever caused the signal, while with the command line tools there's no
      great benefit over just letting the shell report the signal.

    * Use pkg-config to probe for libav and proj, which sorts out the correct flags
      for building on OS X against a static install of libav.

    Changes in 1.2.18 (2015-06-03):

    * aven:

      + Add support for reading terrain data (from a zip file containing either an
        SRTM .hgt file, or an ESRI .bil file and associated metadata files), and
        rendering it as a transparent surface.

      + Remove actions from 'Orientation' and 'Rotation' menus which you wouldn't
        sanely want to perform from the menu.

      + Create a "Colour by" submenu of the "View" menu to house the various
        colouring options.

      + Add "Colour by Gradient" and "Colour by Length".

      + Make the button to dismiss the "About" dialog "OK" rather than "Close",
        which seems more logical, and also allows the dialog to be closed by
        pressing "Escape".

      + Destroy any existing clipping region before we write the page footer.
        Hopefully solves ticket #52, reported by Erin Lynch.

      + Don't round bearing and tilt angles to integers when printing and
        exporting.

      + Add passage export for EPS format.  (Partly addresses ticket #4)

      + Add JSON export.  This should be regarded as experimental, and the format
        is quite likely to change.

      + Pressing F6 now toggles the display of rendering stats, currently FPS
        (Frames Per Second) and the number of triangles in the terrain mesh.

      + Add a menu item and toolbar button to show the cavern log window if the
        currently shown survey data was processed by aven.  Reported by Hugh St
        Lawrence in #47, and by Dave Clucas and others previously on the list.

      + Add "Save Log" button to Aven's cavern log window.

      + In cavern log window, highlight "error" markers in red and "warning"
        markers in orange.

      + Rework code to read cavern's output.  In particular, we no longer mix
        buffered and non-buffered system calls.

      + Aven's support for reading colours and font sizes for printouts from
        print.ini has never worked - the contents of the ini files are ignored due
        to a bug which has been there since the code was added in 2005 - but nobody
        has ever complained.  So just strip out that code entirely - we should
        support setting the colours and font sizes, but a GUI interface for setting
        them would be better.

      + Fix to compile with a Unicode build of wxWidgets 2.8.  Reported by Bill
        Gee.

      + Take the width of the messages used above the compass and clino into
        account when calculating how much space to allow for them - now the labels
        won't overlap or be cut off in translations where they are long.

      + (Mac OS X version): Attempt to address the size of the toolbar icons.

    * cavern:

      + Reject *fix with SDs which aren't all positive.  (fixes#2, reported by
        susscorfa).

      + Use the currently set units when outputting measurements in warnings,
        errors, and the stats at the end of the run.  Requested by Bill Gee.

      + Include column number when a *include file isn't found.

      + Show 'error' in front of error messages, like we show 'warning' in front of
        warnings.  Fixes #48, reported by Wookey.

      + Increase the threshold for warning that fore and back measurements differ
        from 2 SDs to 3 SDs.

    * findentrances: If the 3d file specifies the coordinate system, use it.

    * svxedit: Remove svxedit - while an editor with built-in knowledge of survex
      would be nice to have, svxedit doesn't really offer that, and it looks ugly
      in a modern desktop.

    * If we run out of memory while reading a processed survey data file, include
      the filename in the error message.

    * Many translation updates - notably Indonesian and Russian are now the two
      most complete translations.

    * (Microsoft Windows version): Add code page 1252 mappings for fancy quotes.

    * Transliterate gradient and infinity symbols if the current character set
      lacks them.

    * Add SVG version of .plt icon.

    * Manual:

      + Add complete list of quantities you can set SDs for.  Thanks for Wookey for
        highlighting that the previous list was incomplete.

      + Document averaging of a group of repeated readings.

      + Add a link to the sample data from the manual.

      + Remove references to contact addresses which are no longer there.  Remove
        offer to post people floppies, and references to a CD image which isn't
        available for download.

    * Remove non-breaking spaces from the diffpos and extend manual pages, as they
      actually make the output formatting worse (presumably these used to work
      around a since-fixed bug in one of the docbook processing tools).

    * doc/TODO.htm: Update.

    * Fix to compile without warnings with 'g++ --std=gnu++11'.

    Changes in 1.2.17 (2015-02-24):

    * MacOS X version:

      + Update INSTALL file with current status.

      + Aven.app now has a custom icon.

      + Add icons for all the filetypes supported.

      + Add Finder actions for .svx, .3d, .plt and .pos files.

      + aven: Hide the status bar and tool bar in Full Screen mode, as wx doesn't
        currently do this for us.

      + aven: Fix short-cut for toggling Full Screen mode.

      + aven: Make "About" menu item appear.

      + aven: Fix "Close" button in about dialog.

      + aven: Make custom cursors black with a white outline to match the standard
        OS X cursor.

      + svxedit: Now wrapped up in an application bundle as svxedit.app.  It
        still doesn't really work like a standard app though - e.g. you can't load
        files from Finder (instead run svxedit.app and use File->Open), the font
        size of most menu items is wrong, the icon for the app is the wish icon
        rather than the svxedit icon, shortcuts use Ctrl not the Cmd key, and
        probably more.  I'd probably recommend using another editor (OS X comes
        with TextEdit.app for example).

      + The documentation is now in a "Docs" directory alongside the apps, rather
        than in the rather less obvious "share/doc/survex" directory.

      + Default to building for x86_64, since all modern Macs are 64 bit.

      + Disable use of liblzma when building wxWidgets for OS X, which was
        preventing the build from working on OS X 10.6.8.

      + Download wx sources from SF via redirecting link.  Thanks to David A.
        Riggs.

      + buildmacosx.sh: Handle the mount point for the disk image containing a
        space.

      + Link with a static build of PROJ for doing coordinate system conversions.

      + Build wx with --disable-webview to avoid a compilation failure on OS X
        10.10.1.

      + Use wx-config --cc and --cxx to get the compilers to use for building
        everything else, as wx adds options to them which otherwise cause linking
        errors.

      + The diskimage (.dmg) file is now compressed with bzip2, which gives a
        smaller download.  This means OS X 10.4 is required, but we probably
        already need at least 10.5 because that's the minimum version which the
        wxWidgets build supports by default.

      + Remove unused files and copies of files from the diskimage.

    * cavern: If the same leg is repeated consecutively, average the readings and
      treat as a single leg.

    * dump3d: Report SEPARATOR used by the file being read.

    * aven.svg: Fix visual glitch in SVG icon for aven.  Noted by David A. Riggs.

    * aven:

      + Greatly reduce flicker when mouse is moved to the top of the screen in full
        screen mode and the menu bar reappears.

      + For export formats where scaling is supporting, aven now actually uses the
        scale specified in the export dialog (previously it ignored this and used
        1:500).

      + Reimplement animation so that it's based on angular change per unit of
        elapsed time, rather than averaging the time take for the last two scene
        redraws.  This gives smoother animation in the face of variable load and
        scene redraw time, and should be more consistent between platforms.

      + Switching to a point of the compass during auto-rotation now jumps straight
        there rather than the two animations fighting.

      + Reduce the maximum auto-rotation speed, as the previous limit was uselessly
        fast.

      + Disable stepping the rotation angle when animating (previously we only did
        when rotating).

      + Speed up start-up a bit - rather than loading icons from individual PNG
        files on disk, compile them into the aven binary.

    * (Unix version): Add "MimeType" field to desktop files so that file
      associations work out of the box with modern desktop environments.

    * Add start of Hungarian translation from Imre Balogh.

    * Merge in many updates to the Russian translation from "vsuhachev".

    * Assorted minor updates to other translations.

    * Create scalable (SVG) versions of file type icons.

    * doc/manual.sgml: Remove $Id and $Date markers, as they don't get expanded now
      we're using git.

    * tests/: Improve test coverage in a few places:

      + Extend tests of fore and back sights to test calibration of the back
        compass.

      + Test "Can't calibrate angular and length quantities together" error.

      + Check that "*set names ." works when "." is also the decimal point.

    Changes in 1.2.16 (2014-10-17):

    * aven: Add KML export (stations only currently).

    * aven: Allow measuring line to measure from anonymous stations.  (Fixes #44)

    * aven: Fix corrupted names in exported files.

    * aven: Fix error log window under wxWidgets >= 2.9 to include the system
      information before the first log message like it does under wxWidgets 2.8.

    * cavern: Add support for "*cs JTSK" and "*cs JTSK03".

    * tests/: Improve test coverage.

    * Translation updates for many languages, plus the start of translations to
      Greek and Polish.

    * Fix to build against wxWidgets 3.0 built with assertions disabled.  Reported
      by Martin Sluka.

    * Fix warnings when compiling with clang (which is the default compiler on
      Mac OS X).  Reported by Martin Sluka.

    Changes in 1.2.15 (2014-08-14):

    * cavern: The *cs command now also supports "long-lat", "s-merc" (for "Web
      Mercator"), EPSG and ESRI codes, "eur79z30", "ijtsk" and "ijtsk03".  This
      means that we now support all the coordinates systems which Therion does,
      except for a few which don't have X=East and Y=North.  The documentation
      for *cs has also been improved.

    * aven: We no longer persist full screen mode between runs - it's not a
      standard behaviour of desktop programs, and it's too easy to go into full
      screen mode from the menu and then not be able to get out again because you
      don't know the required key shortcut. (ticket#39)

    * aven: When in full screen mode, moving the mouse to the top of the screen now
      makes the menu bar appear.  This provides a non-shortcut way out of full
      screen mode, as well as making it easier to perform other operations while in
      full screen mode.  The current implementation gives an annoyingly flickery
      transition, but hopefully we can improve this in future. (ticket#39)

    * (MacOS X version): If built with wxWidgets >= 3.1.0 (which is still in
      development), we now call EnableFullScreenView() which improves the full
      screen mode experience on OS X 10.7 and later.

    * img library: Improve documentation for img_ERROR_INFO.

    * tests/: Ship some missing .out files and compare.tst.

    * tests/: cavern.tst testcase back2 is now actually used.  Fix a bug in this
      testcase, and extend it to cover a variant of the situation reported as a bug
      in therion by Bill Gee to the therion list.

    * (Linux version) survex.spec: Add run-time requirement on proj and proj-epsg
      for the survex package and on tk for the svxedit package.

    Changes in 1.2.14 (2014-07-05):

    * img library: Add ability to store a PROJ4 string describing the coordinate
      system in use in 3d v8 files.

    * aven: If the 3d file specifies a coordinate system, then use it for exporting
      to formats which need to know (currently GPX).  If the input file doesn't
      specify the coordinate system, allow the user to enter a PROJ4 string in the
      export dialog.

    * aven: You can now quickly zoom to a particular area by holding down the
      "Shift" key and dragging with the left mouse button to create a rectangular
      "rubber band box" around the area you wish to zoom to.  If you release the
      "Shift" key while still dragging, the box is centred on the start point
      rather than having one corner there.

    * aven: Fix exporting of passage tubes in elevations and extended elevations
      - previously up and down were getting drawn across the page!

    * aven: Fix "Cancel" to work on the print/export dialog, broken by changes in
      1.2.13.  (Reported by Brian Clipstone)

    * aven: Fix the conditions on which the menu item "Cancel measuring line" is
      enabled - previously it was hard to actually cancel it via the menu.
      Reported by Hugh St Lawrence.

    * aven: Fix wx assertion failures when showing hit test debug view on platforms
      such as 64-bit Linux.

    * aven: When viewing from above, show "Plan" above the "clino" which indicates
      the tilt angle (instead of "Elevation -90°").

    * aven: The extended font data now loads faster, and also uses less memory on
      64-bit platforms.

    * aven: Dragging the vertical divider between the side panel and the 3D view
      now only updates when you finish the drag, as redrawing continuously just
      looks clunky except on an ultra-fast machine.

    * aven: (German translation) Abbreviate "Blickrichtung" so it doesn't overfill
      the space available in the aven UI.

    * cavern: Add a *cs command to allow setting the coordinate system for *fix
      commands, and the coordinate system used for processed survey data.  The
      latter is now stored in 3d v8 format files.

    * cavern: Add support for 'L' flag (exclude from length) in Compass .dat files
      and handle it in the same way as the "DUPLICATE" flag in .svx files.

    * cavern: If there's more than one *fix command with coordinates, still
      actually fix the second and subsequent ones, to avoid triggering bogus errors
      about unconnected surveys.

    * cavern: If there's more than one *fix command with coordinates, report the
      station name of the previous one, plus the file and line number where it was.

    * cavern: Fix handling of the rather contrived case of *fix with no coordinates
      followed by *solve and then another *fix with no coordinates not to access
      freed memory.

    * dump3d: Report any specified coordinate system.

    * doc/3dformat.htm: Update to document how the coordinate system is stored.

    * (Microsoft Windows version): Include dump3d in the installer.

    * Fix a compiler warning.

    * Improve test coverage.

    Changes in 1.2.13 (2014-05-15):

    * aven: Fix --print option to wait for printing to happen before exiting
      (previously it would exit right after opening the print dialog, so you
      couldn't actually print anything out using it).

    * aven: Increase the threshold for how close the pointer needs to be to a
      station from 5 pixels to 7 to try to help touchscreen users.  Reported by
      Hugh St Lawrence.

    * aven: Add "fat finger" mode, toggled by pressing F2, to allow investigating
      if increasing the minimum pointer to station threshold helps Hugh's problems
      with using aven on a touch screen device.

    * aven: The measuring line was unable to see stations which had just been
      revealed by toggling surface or underground legs on - this is now fixed.

    * aven: Add "hit test grid debug" mode, which shows the hit test grid and how
      many entries are in each box (toggled by F3).

    * aven: Pressing F4 now allows the user to toggle wxWidgets assertion messages
      off and back on.

    * aven: Create the empty hit-test grid data structure lazily, to reduce start
      up time a little.

    * cavern: Improve messages which talk about "tags" and/or "prefixes" in *begin
      and *end commands to instead talk about "survey names".

    * cavern: For ages cavern has warned if you reentered a survey, but this
      warning was suppressed if it occurred at the same line of the same file as
      the survey was first entered, but this can only happen if you include the
      same survey file more than once, which isn't a sensible thing to do for a
      file with actual survey data in (you might reasonably do it to set up survey
      grade details or something like that).  The warning is now given in this
      situation too.

    * cavern: After 5 warnings about reentering a survey we give up warning about
      it, but we used to keep reporting where the survey was originally entered -
      this secondary diagnostic message is now silenced when the main message is.

    * (Microsoft Windows version): Compile C code with optimisation on.

    * Add the start of a Russian translation, with messages take from therion.

    * Minor translation updates to French.

    * Fix compiler warning from GCC.

    * Testsuite improvements:

      + Test that "..." anon station works.

      + cavern.tst: Check number of errors returned by all testcases which should
        fail and give an error count.

      + cavern.tst: Fix to actually fully test everything when builddir != srcdir.

    Changes in 1.2.12 (2014-04-14):

    * aven: Fix measuring line to show change in altitude rather than altitude
      itself (accidentally broken by changes in 1.2.11).  Reported by Brian
      Clipstone.

    * aven: Fix printing when built with wxWidgets 3.0.

    * aven: Several visual improvements to printouts:

      + Move the numbers below the scale bar down a little so that they don't
        overlap the scale bar ticks.

      + Set the clipping region after we draw the page border and info box to avoid
        clipping the border in print preview.

      + Tidy up the appearance of the compass and elevation arrow.

    * aven: Fix to build with libav 10.  Reported by Moritz Muehlenhoff in
      <http://bugs.debian.org/739332>.

    * aven: Fix to build with older libav where avcodec_free_frame() isn't
      available.

    * (Linux version) survex.spec: Update spec file used for building RPM packages.

    * (Unix version): Add "Keywords:" entry to .desktop files.

    * (Unix version): Enable large file support, mostly to support filing systems
      which return 64 bit inode values, such as CIFS mounts.

    * (Microsoft Windows version): Only allow "A-Z" or "a-z" for driver letters,
      rather than any character which is a letter in the current locale.

    * Various translation updates.

    Changes in 1.2.11 (2014-01-28):

    * aven: Fix wxWidgets assertion when double clicking on an anonymous station.
      Reported by Kevin Dixon.

    * aven: Embed the font data for the first 256 Unicode characters for use in the
      survey pane into the compiled aven binary to reduce start up overhead.  Any
      additional characters needed are loaded from a data file only if/when a
      character >= U+100 is actually needed (as before).

    * aven: Fix display of Unicode characters above 256 when there's a character
      <= 256 earlier in the same string.

    * aven: Use the actual width of Unicode characters above 256 rather than
      assuming they are 16 pixels wide.

    * aven: If full screen, don't show the side panel when a new file is opened
      (e.g. via Ctrl+O).

    * aven: Don't give an assertion failure when showing passages for a cave with
      no vertical extent.  Reported by Jonny Prouty.

    * aven: Change terminology in print dialog - say "legend" instead of "info
      box".

    * aven: Add option to show the tilt angle as a percentage gradient.

    * aven: Show the units (degrees, grads, or percent) for the tilt and bearing
      indicators.

    * aven: All length units are now translatable.

    * aven: Split log_fl_error helper function out of CHECK_GL_ERROR macro, which
      will reduce code size and also the number of deprecation warnings about
      gluErrorString on Mac OS X 10.9.

    * (Microsoft Windows version): aven: Try to work around redraw issues related
      to the measuring line by redrawing the whole window, which doesn't seem to be
      measurably slower.

    * cavern: If *units is used to try to set units for LEVEL, PLUMB, or POSITION,
      give an error rather than quietly ignoring the attempt.

    * cad3d: Make cad3d remap control characters and spaces in station names when
      generating PLT output in the same way aven does.

    * Various translation updates (particular thanks to Eric Madelaine and Dennis
      Baudys), including the start of a Bulgarian translation, with messages taken
      from Therion and elsewhere.

    * (Microsoft Windows version): On Microsoft Windows 2000 and newer, use
      GetUserDefaultUILanguage() to get the UI language to use.  For older
      versions, continue to use GetUserDefaultLCID().

    * (Microsoft Windows version): The Indonesian translation will now be used
      automatically when the system language is set to Indonesian.

    * (Mac OS X version): Fix to build with wx 3.0.0 on OS X 10.9.  Thanks to David
      A. Riggs for his work on this.

    * (Mac OS X version): Update buildmacosx.sh script to use wx 3.0.0, and add a
      checksum check for the downloaded wx sources.

    * Fix a lot of the compiler warnings when building with clang.

    * doc/manual.sgml: Add missing quantities to the list documented as accepted by
      *units: LEFT, RIGHT, UP/CEILING, DOWN/FLOOR (missing entirely);
      BACKCOMPASS/BACKBEARING, BACKCLINO/BACKGRADIENT (missing from the main list,
      mentioned in list of the units that can be set for them); COUNT (missing
      alternative name for COUNTER); DX/EASTING, DY/NORTHING, DZ/ALTITUDE
      (incorrectly listed as X, Y, Z).  Reported by Jonny Prouty.

    * Test suite: Improve test coverage for cavern.

    Changes in 1.2.10 (2014-01-15):

    * aven: Fix assertion if two mouse buttons are held down at the same time.
      If dragging with more than one mouse button held down, releasing one causes
      another which is still held down to take effect.  Reported by Brian
      Clipstone.

    * aven: If we fail to start the external editor when the user clicks on an
      error or warning from cavern, show an error box.

    * aven: If the survey has a title, add it as a top-level <title> element to
      exported SVG files.

    * aven: Escape '<', '>', and '&' in labels in exported SVG files.

    * aven: In GPX export, set the <time> element to the datestamp from the 3d
      file.

    * aven: Don't try to write the title if it isn't set or is empty when exporting
      GPX files.

    * aven: Don't bother looking up the printer page setup info when exporting.

    * (Microsoft Windows version): aven: Fix crash on "File->Print" or
      "File->Export" under Windows XP, reported by Brian Clipstone.

    * (Microsoft Windows version): aven: Fix error dialog about an incorrectly
      encoded filename which could occur if run without being asked to load a file
      on startup.

    * (Microsoft Windows version): aven: Compile with optimisation on.

    * img library, aven: Although processed CMAP data files are often referred to
      as "CMAP .XYZ files", it seems that actually, the extension .XYZ isn't used,
      rather .SHT (shot variant, produced by CMAP v16 and later), .UNA (unadjusted)
      and .ADJ (adjusted) extensions are.  Since we've long checked for .XYZ, we
      continue to do so in case anyone is relying on it, but also check for the
      other extensions.

    * img library: Add new "datestamp_numeric" field to struct img giving the
      datestamp as a time_t in UTC (or (time_t)-1 if there's no datestamp or we
      failed to convert it).  For .3d >= v8, this field is reliable.  We attempt to
      convert date strings in .3d <= v7 and CMAP XYZ files, but may get the
      timezone wrong.

    * img library: Fix my_strcasecmp() to handle top-bit set characters better.

    * cavern: Fix NULL pointer dereference when processing Compass DAT file without
      'SURVEY DATE:'.

    * doc/manual.sgml: Update references to Survex 1.1 which should be to 1.2.

    * doc/manual.sgml: Note the station length limit Smaps used.

    * Fix some compiler warnings if built with glibc's fortify source feature
      enabled.

    Changes in 1.2.9 (2014-01-08):

    * Document --3d-version in cavern man page and the manual.

    * aven: Fix compilation error in movie export code with recent libavi.

    * aven: Fix warning on stderr when export a movie as MPEG.

    * img library: In non-hosted mode, don't define GETC and PUTC if they're
      already defined, to allow easy overriding with getc_unlocked() and
      putc_unlocked() (which are significantly faster on Linux).

    * img library: In non-hosted mode, check that int is at least 32 bits,
      and if not, use long.  In practice, platforms with 16 bit int are mostly
      obsolete, but it's not hard to be portable here.

    * img library: Add test that img.c and img.h compile in non-hosted mode
      (regression test for issue fixed in 1.2.8).

    * (Microsoft Windows version): aven is now built with wxWidgets 3.0.0.

    * Update translations from launchpad and from existing similar messages.

    * Fix some compiler warnings.

    Changes in 1.2.8 (2013-10-29):

    * cavern: Fix handling of anonymous wall stations ('..' by default) to
      implicitly set the SPLAY leg flag, as was intended.  Reported by Thomas
      Holder.

    * cavern: Tweak .err file output not to lose the space in front of certain
      statistics when the value gets large.

    * cavern: Eliminate redundant progress message when solving simultaneous
      equations.

    * aven: Add a format drop down to the export dialog, and only show fields which
      are meaningful and supported for the currently selected export format.  The
      format defaults to that used most recently.  The "Elements" and "View" boxes
      have been swapped in the print and export dialogs as that layout works much
      better when the "View" box is hidden.

    * aven: Changing checkboxes in the print or export dialog didn't work in 1.2.7
      - now works again.  Reported by Anthony Day.

    * aven: Add GPX export (based on findentrances patch from Olaf Kähler).  In
      this release the projection which the survey coordinates are in defaults
      to the BMN M31 grid used in the Totes Gebirge in Austria.  On Unix, you
      can edit ~/.aven and add a new line setting 'input_projection' to a PROJ
      projection string.  The ability to specify this projection in a better
      way is coming soon.

    * aven: New export options "Origin in centre" and "Full coordinates" - the
      latter fixes #10.  GPX and PLT output implicitly force "full coordinates".

    * aven: The "Sketch" vector drawing program got renamed to "Skencil" some
      time ago, so update references.

    * aven: Make the Presentation->Play menu item a checkbox, to avoid a warning
      with wxMSW 2.9.5.  Reported by Brian Clipstone.

    * aven: Make right click in an empty presentation mark the current position and
      open it to edit, instead of crashing.

    * aven: Update movie export code to work with latest libav API.  Reported by
      Sebastian Ramacher.

    * aven: Improve reporting of errors during the process of exporting a movie.

    * aven: Don't try to close the movie if we aren't producing one.

    * aven: Fix assertion failure when double-clicking on the survey with wx2.9.

    * aven: Fix to build with wxMSW 2.9.5.

    * aven: Fix to build with wx 2.9.5 with wx2.8 compatibility disabled.

    * cad3d: The "Sketch" vector drawing program got renamed to "Skencil" some time
      ago, so add a new --skencil option to specify this output format.  The old
      name (--sketch) is still recognised for compatibility.

    * cad3d: Make --marker-size work for Skencil and SVG output.

    * dump3d: Make --show-dates option show dates for XSECT.

    * img library:

      + Fix to work once more when used outside of Survex (missing definition of
        max() macro and a bad call to free() in img_close() for a file opened for
        reading).

      + Use lround() instead of round(), and make the tests around whether we use
        the library function or the our fallback implementation saner.

      + Fix // comments in C code for portability to pre-C99 compilers which don't
        support these as an extension.

      + Can now be compiled as C++ as well as as C.

    * (Microsoft Windows version): The installer is now built with a newer version
      of Innosetup, and includes translations for all the languages which Survex
      itself has any translations for.

    * (Microsoft Windows version): aven is now built with wxWidgets 2.9.5.

    * Minor translation updates.

    * tests/Makefile.am: Distribute files for "normal_bad" testcase.

    Changes in 1.2.7 (2013-07-27):

    * Add support for anonymous stations, which are indicated by one, two or three
      separator characters - with the default separator of '.', that means '.',
      '..', and '...' are anonymous stations.  Single separator ('.' by default)
      is an anonymous non-wall point, double separator ('..' by default)
      is an anonymous wall point at the end of an implicit splay), and triple
      separator ('...' by default) is an anonymous point (with nothing special about
      the leg).  A new *alias command allows '-' to be mapped to '..' for
      compatibility with pocket topo: *alias station - ..

    * New version 8 of the 3d format:

      + Supports new flags img_SFLAG_ANON and img_SFLAG_WALL.

      + New explicit file-wide flag for 'this is an extended elevation', rather
        than modifying the survey title to indicate this.

      + The survey prefix is often unchanged from one leg to the next, so use a
        spare flag to compactly indicate when there's no label change.

      + The data style of each leg is now stored.

      + The "processed at" time is stored as seconds since 1970 rather than a
        human-readable string.

      + Since 3d v8 features significant changes to the format, the format
        documentation for v7 and earlier has been split off into 3dformat-old.htm.

    * img library:

      + New station flags img_SFLAG_ANON and img_SFLAG_WALL.

      + Handle .pos files containing unnamed stations - don't suck the next line in
        as the station name, and set img_SFLAG_ANON for them.

      + Repurpose the long unused fBinary parameter to img_open_write() as a flags
        parameter, and add img_FFLAG_EXTENDED to specify that this is an extended
        elevation, in place of appending " (extended)" to the title.  Internally we
        still append this to the title (and remove it upon reading) when writing
        3d v7 or earlier, but for the new 3d v8 format, this flag is stored
        explicitly in the file.

      + img.h: Add comments for the lists of "Leg flags" and "Station flags".

    * aven:

      + We now require at least wxWidgets 2.8.0 - it was released over 6 years ago
        now, and the wx developers consider even 2.8 to be rather long in the
        tooth.  We stopped testing building with wxWidgets 2.6 some time ago, and
        formally dropping support for older versions allows a number of workarounds
        to be removed from the aven source code.  Also, features deprecated in
        wxWidgets 2.9 are no longer used in our code.

      + Don't run incremental search on every key-press, as on a slow machine the
        short initial search(es) will take a while but not be useful.  Instead only
        actually run the search when we're told there are no more key-presses
        queued up.

      + Implement support for including cross-section information in exported SVG
        and DXF files (ticket#4).  The DXF export is untested currently.

      + Show splay legs faded by default, with menu options to hide them or show
        them like other legs.

      + Speed up loading a .3d file with cross-sections by using a map to convert
        station names to positions.

      + In the cavern log window, don't highlight a file:linenumber if there's no
        message after it, which avoids highlighting the "Included from" lines
        wrongly.

      + Fix not to crash when trying to report an error while starting up.

      + (MacOS X version): Change the menu shortcut for "Full Screen Mode" to be
        the OS X standard shortcut Shift-Command-F (previously we used F11, but
        that's used by the desktop).

      + Add checks for errors when reading the font file.

      + Remove useless extra quoting when invoking vim to show the location of an
        error from cavern.

      + Include GL/gl.h before GL/glext.h (needed on Debian wheezy).

      + Use wxValidator to simplify keeping svxPrintDlg member variables and fields
        in the dialog in sync.

    * cavern:

      + Demote errors about invalid dates to warnings, since we've accepted *date
        for ages without any checks on the value, and so existing datasets
        probably contain invalid dates and dates in other formats.  (ticket#19)

      + New *alias command allows '-' to be mapped to '..' for compatibility with
        pocket topo: *alias station - ..

      + We want to warn if there's a clino reading which it would be impossible to
        have read from the instrument (e.g. on a -90 to 90 degree scale you can't
        read "93" (it's probably a typo e.g. for "39").  However, the gradient
        reading from a topofil is typically in the range 0 to 180, with 90 being
        horizontal.  Really we should allow the valid range to be explicitly
        specified, but for now we infer it from the zero error - if this is within
        45 degrees of 90 then we assume the instrument can read between 0 and 180
        degrees.

      + If the survey isn't all connected, still run survey tree checks and report
        errors and/or warnings which might suggest typo locations.  Thanks to Kevin
        Dixon for the report which highlighted this issue.

      + Report a warning if *begin SURVEY has a separator character in SURVEY.

      + Report column numbers as well as line numbers for some cavern errors and
        warnings.

      + Adjust width of node stats table to fit longest count when there are more
        than 9999 of a particular order of node.

      + If the argument to *include has an opening double quote but the closing
        double quote is missing, then skip trying to open the file.

      + Move "Station X referred to just once" warning after non-existent survey
        check - if both fire, the non-existent survey error is likely to be more
        relevant.

      + We no longer follow an error for a bad reading in passage data with a bogus
        "End of line not blank" error, but instead check the remaining readings on
        the same line.

      + We no longer follow an error about OMIT for a required reading with a bogus
        "End of line not blank" error.

      + Report an error if the scale factor in *calibrate is zero - it doesn't make
        sense and probably means someone reversed the arguments to *calibrate.

      + Report the parent include files starting from the outermost, as that's more
        logical when there are multiple levels involved.

      + If we were expecting a numeric field and instead get something which starts
        with '+', '-', or '.' but which isn't a number, then fix the error to
        include that character in the token reported.

      + Simplify handling of quantity lists to only recognise 'DEFAULT' as the
        first item.

    * cad3d: Check for errors from img_rewind() and report them.

    * dump3d:

      + Build, install and package dump3d as standard - it's useful for grabbing
        info from 3d files in scripts.

      + Add --show-dates option.

      + Show only 2 decimal places on coordinates and passage dimensions.

      + Report the data style of legs.

      + Report if the file is an extended elevation.

      + Report img_STOP as STOP rather than CODE_0xffffffff.

    * Test suite:

      + cavern.tst: Fix equatenosuchstn testcase (added in 1.2.6) to normalise the
        expected output so it passes reliably.

      + cavern.tst: Run diffpos <expected> <actual> so the reports of 'Added' and
        'Deleted' stations upon failure are the more natural way round.

      + Add more testcases, expand some existing testcases, and add expected output
        for more.

    * (Microsoft Windows version): Use wx-config's --cc and --cxx flags to find the
      appropriate C and C++ compilers to use, and link mingw build statically to
      avoid needing the libgcc DLL (which newer GCC seems to have by default).

    * (Unix version): When determining the character set for command-line tools,
      check environmental variable LANG after LC_ALL and LC_CTYPE.

    * When determining the language, check environmental variable LC_ALL before
      LC_MESSAGES and LANG (but after SURVEXLANG).

    * If we don't find the message file, only give an error if it was specified
      with SURVEXLANG, since that is an explicit instruction to Survex, whereas
      LANG, LC_ALL and LC_MESSAGES are essentially system "preferred locale"
      settings.

    * There are a handful of hard-coded English message strings for reporting
      errors trying loading message files, etc.  These are all now ASCII, as if we
      fail trying to open a message file, it's more likely the encoding isn't
      set correctly.

    * Prune strings we are no longer using and are probably unlikely to use again
      into a new file po_codes_dead, so that translators don't get presented with
      them to translate.

    * Merge lots of translation updates.  Most translations are now complete or
      close to complete.

    * Add start of Indonesian translation from Arief Setiadi Wibowo.

    * Fix various compiler warnings when building from source.

    * Include scripts gdtconvert and gen_img2aven in the source distribution.

    Changes in 1.2.6 (2012-02-23):

    * (Mac OS X version): Fix so that cavern finds its messages when run by aven.

    * (Microsoft Windows version): Include JPEG images for aven in the installer
      package (ticket#35).

    * cavern: If we have a reference to a station in a non-existent survey, give a
      helpful error rather than saying the station hasn't been exported from the
      survey.  (Bug reported by Martin Green via email)

    * aven: Fix to build with a non-Unicode wxWidgets library.  Patch from Olaf
      Kahler.

    * findentrances: Add findentrances utility from Olaf Kahler which produces a
      .gpx file with waypoints for entrances.  This needs libproj so is disabled
      by default for this release - to enable it install the development stuff for
      libproj and build survex with:

          make FINDENTRANCES=findentrances
          make install FINDENTRANCES=findentrances

    * dump3d: Add support for showing img_ERROR_INFO items.

    * doc/3dformat.htm: Merge in some improvements from Mike McCombe.

    * Incorporate a French translation from launchpad I'd previously copied the
      English version of by mistake.  Attempt to correct mistranslation of "survey
      file".

    Changes in 1.2.5 (2012-01-03):

    * aven:

      + The survey tree in the left panel is now in sorted order once more.

      + No longer fails with an assertion if used for a long time (we were leaking
        an OpenGL list each time one had to be regenerated).

      + Now builds with newer FFmpeg library.

      + Draw measuring line in front of the indicators rather than behind them.

      + Loading a new file (or reloading the current one) no longer invalidates
        the OpenGL lists for the compass and clino, so will be a fraction faster.

    * Improve handling of attempts to look up translated messages before the
      message subsystem is fully initialised (which only happens if there's an
      error early on).

    * Improve the survex(7) man page text, and fix it to be marked as section 7 in
      the man page source as well as in the filename.

    Changes in 1.2.4 (2012-01-01):

    * aven:

      + A change in 1.2.3 meant that aven tried to use OpenGL before it was
        initialised, which doesn't cause problems in some machines, but causes aven
        to abort on others.  This is now fixed, and there's a check in place to
        help avoid similar issues in future. (ticket#34)

      + Always use metres or feet for the depth colour key, and choose a consistent
        precision by looking at the depth range. (ticket#30)

      + Show the depth units below the colour bar rather than after every value.

      + When zooming way in, stay in metres rather than switching to cm.

      + On the scale bar, say “1 mile” rather than “1 miles”.

    * Translation updates for Catalan, French and Slovak.

    Changes in 1.2.3 (2011-12-31):

    * Fix to build with wxWidgets 2.9.2.

    * (Mac OS X version):

      + Processing .svx files from aven now works.

      + Remove spurious blank lines from the licence text in "Get Info".

      + Don't create the help menu at all, as it is empty (because the "About"
        entry goes elsewhere) and sometimes seems to appear in the UI.

      + INSTALL.OSX: Update to reflect current status.

    * aven:

      + Fix Y coordinates of surface surveys on printouts.  (Closes #32)

      + Improvements to text plotted on the survey pane:

        - Support plotting Unicode character points > 256 by lazily loading the
          data for them from the font file and plotting them with a direct call to
          glBitmap(), which is slower but doesn't require a display list per
          character.

        - Adjust the spacing from fixed width to putting a one pixel gap either
          side of each one character (so two between adjacent glyphs).  Mostly this
          reduces the horizontal width, but it adds a pixel for characters like "m"
          and two in a few cases.

        - Fix .pixelfont file generation to correctly handle characters wider than
          8 pixels.

      + Fix expected cross shape so don't always reject using texture mapping to
        draw crosses.

      + As we read a survey file, eliminate tubes consisting of zero XSECTs as well
        as those consisting of just one.  Previously we would trip over the empty
        tube later.  Such tubes can for example be created by extend if a splay shot
        is the start or end of a tube.

      + Make the green colour used for entrances in the survey tree the same
        (slightly darker than before) green used for the entrance blobs.

      + Report the version of the library we're actually running with if built
        against wx >= 2.9.2.  Make it clear that the version reported is the
        version *built* with for wx < 2.9.2.

    * extend:

      + Copy the end markers for passage tubes.

      + Preserve left and right data for tubes (previously they were set to -1.0
        which means "no info").

    * img library: Fix incorrect comment in img.h which claimed that img_XFLAG_END
      was no longer used - it certainly is!

    * Use curly double quotes instead of "`" and "'" to quote filenames, etc in
      messages, and curly single right quote instead of straight ASCII apostrophe.
      Fall back to using straight ASCII versions if we can't represent them in the
      current character set.

    * Translation updates for Catalan, French, Slovak and Spanish.

    * Test suite:

      + Add test coverage for interleaved diving data.

      + Add testcase for diving data with topofil-style distance.

    Changes in 1.2.2 (2011-10-06):

    * aven:

      + Replace the textured-mapped font drawing with an approach based on
        glBitmap.  This doesn't suffer from the character alignment issues which
        the textured-mapped fonts had, and is actually significantly faster on some
        machines.  The current font used is (mostly) fixed-width, but this isn't an
        inherent limitation - it was just the easiest font data to convert to a
        usable format.

      + Fix assertion failure due to rounding differences on loading certain .3d
        files.  (ticket#26)

      + Fix assertion failure when turning on 3D passages if they stick out higher
        or lower than any station.  (ticket#29)

      + Fix grid not to disappear when blobs are turned on and blobs are drawn
        using lines.

      + If a degree sign isn't available in the character set in use, transliterate
        it to 'dg' rather than skipping it.

      + Fix message which should have been a degree sign but got lost in the format
        change for 1.2.0 and then got reassigned in 1.2.1.  Externally, this means
        that bearings in the status bar now have a degree sign after them if they
        are in degrees rather than nothing (1.2.0) or "&Hide Compass" (1.2.1).

      + Fix print dialog to calculate the scale required for "One page" right
        before it calculates how many pages are required, so we don't end up
        something other than 1x1 being shown when the user changes settings.

      + Update the calculations for picking a scale and for deciding how many
        pages are needed to take into account the change in info box height made
        in 1.2.1.

    Changes in 1.2.1 (2011-10-04):

    * Translation updates for US English.

    * aven:

      + Rename the "depth bar" to "colour key" in documentation, menus, etc since
        it now shows colours for dates and errors as well as depths.

      + In the colour key for "colour by date", change "No info" to "Undated".

      + Remove the dark grey background from the colour key and just put a single
        pixel black border around the colours.  This is more in keeping with the
        other controls, and means the colours are now on a black background so more
        visually similar to the survey legs.

      + Move the colour key's "Undated"/"Not in loop" entry down a little to
        improve the appearance.  Make each section a pixel taller.

      + Allow "Colour by X" to be selected even if there's no data for X or only a
        single value of X used (the colour key is much smaller in these cases, and
        does still provide some useful information).

      + Fix incorrect calculation of depth colouring for survey legs which straddle
        a depth band boundary.

      + The scale bar, compass, clino, and colour key now all have right click
        menus which allow related actions to be performed (especially handy in
        full-screen mode).

      + Improve the font used on the survey pane - it now contains the '-'
        character (so the clino now shows negative angles as negative, and dates
        in the colour key are now hyphenated).  Also the spacing and alignment
        are a little better, though still not perfect.

      + PLT file export now handles spaces and control characters in station names
        by escaping them with '%' as in URLs.

      + Pressing "Enter" on a station in the tree control now centres the view on
        that station.

      + The scale bar is now cached in an OpenGL display list since it often gets
        redrawn exactly the same - for example, when rotating, panning, etc.

      + Pressing "F5" forces all cached OpenGL drawing lists to be invalidated and
        then forces a refresh of the survey pane.  This is intended as a debugging
        aid - if pressing F5 changes the display at all then there's a missing case
        where a list should have been invalidated (please report if you find such
        a case as it is a bug).

      + We now automatically track which OpenGL display lists need to be
        invalidated on window width or height changes.

      + Increase scale bar maximum width from 65% of the window width to 75% as it
        was in 1.0.x (except that if that would overlap the clino we now reduce
        that proportion down until it reaches 50%).  Make the limit of zooming in
        the same as in 1.0.x.  (ticket#23)

      + (Linux version): Previously wxGTK didn't really handle showing a dialog if
        the application was fullscreen (the dialog got opened under the main
        window!)  To work around this, aven would switch out of full screen mode
        temporarily while showing a dialog.  This case works properly with recent
        wxGTK, so disable our workaround with versions we know work.  Also, apply
        the workaround only for wxGTK, not everywhere except on Microsoft Windows
        as there's no reason to think we need it for other platforms.

      + Grey out the "View North" action when we're already viewing North, and
        similarly for other compass points.

      + (Mac OS X and Microsoft Windows versions): Fix missing newline to OpenGL
        info in the "About" dialog.

      + Fix to set the correct filename on the root of the survey tree - previously
        the filename of the previous file loaded was used!

      + The movie export code now works with newer versions of the FFmpeg libraries
        as well as still working with older versions.

      + Fix mixed up messages - the print dialog now says "View" on the left
        subgroup of controls rather than some unrelated message.

      + On printouts, combine the "Plan View"/"Elevation" info box field with the
        field which gives the bearing and reduce the height on the info box by the
        removed field, so it's now 3cm for plans and elevations, as for extended
        elevations.  Report the tilt angle for tilted elevations which it seems has
        been missing for ages (it's not in recent 1.0.x either).

      + Tweak the exact positioning of informational text on printouts to look
        nicer and make better use of the available space.

      + Add keyboard mnemonics to the "Plan" and "Elevation" buttons in the print
        dialog.

      + Make the sign of the tilt angle for printouts consistent with the sign
        shown by the "clino" in the survey pane.

      + In the "Print" dialog, when in plan view disable the "Plan view" button,
        and similarly for the "Elevation" button.

      + (Microsoft Windows version): Sort out appearance of custom cursors.

      + If a label isn't valid UTF-8 or CP1252, fall back to ISO8859-1.

      + (Mac OS X version): F11 puts aven into full screen mode, but apparently
        you can't get out again easily, so add code to explicitly check for F11
        being pressed and toggle full screen.

    * (Linux version): Fix the RPM .spec file for where man pages now get installed
      and package aven.svg and the vim support files.  (Fixes from James Begley)

    * "make check" now performs several checks on the translation files.

    * More messages are now available to be translated.

    * cavern: Fix reporting of ranges of survey coordinates, which was broken by
      the message handling changes in 1.2.0.

    * Fix warning when compiling with GCC.

    * INSTALL: Mention building wxWidgets with --enable-unicode.  Mention using
      sudo for installing on Unix.

    * In the manual, replace the instructions for building from source with a
      pointer to the clearer instructions in INSTALL.

    * In the manual, make it clear that installing with administrator rights
      also applies to newer platforms than XP.

    * doc/TODO.htm: Update.

    Changes in 1.2.0 (2011-09-20):

    * Translation updates for Catalan, French, Romanian, Spanish, Slovak, and US
      English.

    * tests/smoke.tst: aven no longer requires an X display for --help or
      --version, so replace skip of this check with a check that this remains the
      case.

    * We now use the standard .po and .pot file formats for storing translations
      (rather than the Survex-specific messages.txt format), and then translate
      these into Survex's .msg format.

    * (Unix version): Move survex man page to section 7 (since it isn't documenting
      an actual command).

    * (Unix version): Write each generated man page to a temporary file, then
      atomically rename, to avoid leaving an empty or partial man page behind if
      docbook-to-man dies (1.1.16 had an empty cad3d.1, and we want to avoid a
      recurrence of that).

    * (Unix version): Default to installing docs into /usr/share/doc/survex rather
      than /usr/doc/survex.

    * aven:

      + Fix handling of accented characters in the survey pane.

      + Aven icon redrawn in SVG format - it's now a vector image which looks
        nicer at larger sizes.

      + Explicitly request double-buffering, which seems to be needed for systems
        with GLX >= 1.3.

      + Fix crash while trying to load certain .3d files.

      + Movie export code updated to work with more recent versions of FFmpeg.
        Currently this is disabled in Microsoft Windows builds, pending getting the
        required libraries set up for building releases.

      + Reporting of errors during movie export improved.

      + Force playback speed to "x1" during movie export.

      + Use stock IDs for buttons where appropriate - such buttons may now be
        rendered with icons on some platforms.

      + If a label isn't valid UTF-8, treat it as CP1252 (the Microsoft superset of
        ISO8859-1).

      + (Unix version): Remove special handling for toggling "full screen" on wxGTK
        as it's no longer required with modern versions.

      + Don't redraw the survey on every mouse movement in the survey pane unless
        the measuring line is (or just was) active.  (ticket #17)

    * cavern:

      + Drop "non-fatal" from the report of how many errors there were at the end
        of the run - it just confuses users - we won't even get here if there's a
        fatal error!

      + Add --3d-version option to allow the user to specify the version of the 3d
        format to output.  (ticket#21)

    * img library:

      + Make the highest and lowest valid values for img_output_version available
        in img.h as IMG_VERSION_MIN and IMG_VERSION_MAX.

    * (Mac OS X version): Fix buildmacosx.sh script to check where the temporary
      volume actually gets mounted.  Fix URL for downloading wxWidgets.

    Changes in 1.1.16 (2011-05-16):

    * Translation updates for German, Spanish, Italian, Portuguese, Brazilian
      Portuguese, and US English.

    * Use horizontal ellipses character rather than '...' and right arrow character
      rather than '->' where these characters are available.

    * (Unix version): Link with -lGL, if it exists, to support linking with gold or
      GNU ld --as-needed (Debian bug #615781).

    * img.c:

      + Fix code typo for IMG_API_VERSION == 0 case.

      + Fix code typo in code used when IMG_HOSTED isn't defined.

    * doc/TODO.htm: Remove entries which have now been done.

    * (Microsoft Windows version): aven: We now include all the available
      translations for messages from wxWidgets, which means that standard widgets
      will appear translated where available even if Survex messages aren't
      translated.

    Changes in 1.1.15 (2010-10-15):

    * aven:

      + In the cavern log window, change the "Rerun" button to "Reprocess" to
        follow terminology in manual and elsewhere.  Fixes ticket#15.

      + When displaying output from cavern, don't update the window after every
        line, but only when we don't have data from cavern pending.  Hopefully
        addresses ticket#12.

      + If we aren't using GL_POINTS for blobs, draw them using a series of
        abutting lines rather than with gluDisk which is faster and gives a
        consistent shape.

      + Check whether blobs and crosses actually render correctly as points/point
        sprites, and if they don't, fall back to drawing them with lines.  The
        best method is cached on disk, and rechecked automatically if the graphics
        hardware is changed or the drivers upgraded.

      + Fix non-USE_FNT case to work again (it's limited to ISO-8859-1 characters
        though, so we still enable USE_FNT by default).

      + Don't offer "All files" wildcard in presentation save dialog.

      + (Microsoft Windows): Handle filenames with non-Latin1 characters in in
        more places.

      + (Microsoft Windows): Quote filenames with spaces and metacharacters in
        when running cavern from aven.  Fixes ticket#11.

    * editwrap: (Microsoft Windows): Handle filenames with non-Latin1 characters.

    * diffpos: Handle files with duplicate labels in better - extend generates
      duplicate labels when it breaks a loop.

    * Enable eswap-break testcase now that diffpos handles duplicate station names.

    * New v7 of .3d format which stores survey dates as number of days since
      January 1st 1900, so we now support dates from 1900-2078 (rather than
      1970-2037) with a smaller file size.  The img API is now versioned - you
      can select the new "version 1" by compiling with -DIMG_API_VERSION=1, which
      gives the survey dates in days in days1 and days2 instead of as time_t
      values in date1 and date2.  Fixes ticket#14.

    * Consistently use http://survex.com/ rather than http://www.survex.com/ - the
      former has been the canonical name for some time, with www.survex.com just
      redirecting to it.

    * (Unix version): Use unlocked file I/O if available, which can be much faster
      in some cases (we don't need the locking as we don't do multithreaded file
      I/O).

    * (Mac version): Fix compilation failure due to clash with Point in Mac OS X
      headers.

    * (Mac version): buildmacosx.sh now works again.

    * Most tests weren't actually running any testcases (looks like a sh
      portability issue).  This is now fixed, and fortunately all tests still pass.

    * Include the extra .isl translation files for Innosetup in the source archive.

    Changes in 1.1.14 (2010-07-26):

    * Restore compatibility with wxWidgets 2.6 (1.1.13 required wxWidgets 2.8).

    * aven:

      + After processing survey data, if there were warnings or errors, add a
        "Rerun" button to allow easy reprocessing after fixing problems.  If there
        were only warnings, also add an "OK" button to allow moving on to viewing
        the processed survey data (fixes ticket#13).

      + Optimise updating of the cavern log window (hopefully fixes ticket#12).

      + Fix links in cavern log window to link from exactly '<file>:<line>' (and
        not the ': ' after), and to make the title for the terminal the
        warning/error message.  Avoid false positives by checking that '<line>' is
        a number.

      + Don't double escape the contents of href and target in links in the cavern
        log window.

      + Improve handling of the splitter window, fixing behavioural glitches in
        various cases.

      + Highlight stations matching any current search when a file is loaded.
        (ticket#9)

      + (Mac version): Fix build issue due to Mac OS X polluting the global
        namespace with its own "Point" class.

      + (Unix version): The Gnome print dialog has its own preview window so
        suppress ours if using the Gnome one.

      + (Unix version): Link aven with -lGLU which SuSE Linux needs.

      + (Microsoft Windows version): Fix handling of a double-click on the survey
        tree when built with wxWidgets >= 2.8.11.

    * cavern: Report relevant file and line number for three warnings which didn't
      give them before.

    * (Unix and Mac versions): configure: Update the wx-config probing code -
      wxmac-config etc aren't present with newer wxWidgets versions so there's no
      point looking for them now.

    * (Mac version): buildmacosx.sh: This script builds a diskimage with Survex in
      for easy installation.  Update it to work with the latest Survex versions
      (use WX_CONFIG not WXCONFIG; use a Unicode build of wxWidgets; if building a
      private wxWidgets, use 2.8.11 not 2.7.0-1).

    * manual:

      + Correctly capitalise "GTK".

      + Note that on Linux we only regularly test builds with the GTK+ version
        (change taken from 1.0).

    * Fixed the cad3d man page, which was an empty file in 1.1.13.

    Changes in 1.1.13 (2010-06-16):

    * Say "wxWidgets" instead of "wxWindows" consistently.

    * img.c: Fix small memory leak (filename_opened member).

    * cad3d, aven: Fix export to SVG when a label contains a '%' character.

    * aven:

      + wxWidgets 2.6.0 or newer is now required.

      + A "Unicode" build of wxWidgets is now supported.  An "ANSI" build may still
        work but hasn't been tested recently (all packaged versions of wxWidgets
        seem to be Unicode now).

      + Fix potential uses of uninitialised variables which may have been causing
        occasional glitches when loading a file on start-up.

      + Improvements to the handling of the font used for plotting labels and other
        text on the survey pane:

        - Loading the font file is more efficient.

        - Character spacing is improved.

        - Default font is now anti-aliased.

      + "About" dialog:

        - Add "Copy" button to copy the system info to the clipboard for easier
          bug reporting.

        - List OpenGL extensions last, since there are usually lots of them with a
          modern gfx card.

        - Fix 100% CPU usage while the "About" dialog is open.

      + Processing .svx files:

        - Passing a .svx file on the command line now works better.

        - Put the survey data log window in a splitter in the usual frame rather
          than opening a separate frame for it.

        - Auto-scroll the log window until we've reported a warning or error.

        - Fix small memory leak.

      + The presentation filename now defaults to using the basename of the
        currently loaded dataset, but we always prompt before we first save with
        such a name.

      + Reduce memory usage when saving a screenshot.

      + Allow "Toggle Fullscreen" to work even if no survey is loaded now that we
        persist the window size (and maximised or fullscreen state) between
        invocations.

      + Fix reporting of OpenGL errors.

      + Fix glitches when tilting while looking East.

      + Added Portuguese and Slovak translations of wxWidgets messages.

    * Documentation:

      + Rationalise manual formats - replace PostScript with PDF and drop RTF.

      + Drop the "alternative manual formats" self-extracting zip file - people
        will generally just want one of the formats, so downloading several
        together isn't very useful.

      + 3dformat.htm: Update for v6 format (thanks to Mike McCombe).

      + GPL.htm: Replace HTML version of licence with a link to the version on
        the FSF website.

      + ChngeLog.htm: Stop generating an HTML version of the ChangeLog - it's too
        low level to be of interest to non-developers, and developers can look at
        the source code.

    * (Unix version): configure: New preferred name for specifying wx-config script
      is WX_CONFIG.  WXCONFIG still supported for compatibility.

    * (Linux version): Source RPM package dropped as you can just build an RPM
      package from the source tarball.

    * (Microsoft Windows version): The installer is now created with a newer
      version of InnoSetup, which gives a 10% smaller download.

    Changes in 1.1.12 (2007-02-07):

    * aven:

      + Remember the window size or maximised/fullscreen state between invocations.

      + Add options dialog to "Export" similar to the one for "Print".

      + The "number of pages required" in the print dialog now updates when you
        change what is to be shown (underground legs/surface legs/station
        names/crosses).

    Changes in 1.1.11 (2006-11-25):

    * Updated Czech, Spanish, and Slovak translations.

    * (MacOS X version): Assorted OS X specific tweaks and fixes.

    * aven:

      + Pick a smaller and clearer font for labels.

      + Fix character spacing.

      + Tweak display of bearing and elevation angles to look nicer with
        proportional fonts.

      + Use the title from the 3d (or plt, etc) file for the window title
        rather than the filename.

      + Show distances to 2 decimal places rather than the nearest integer.

      + Only consider underground legs when calculating the depth bands and
        depth colouring.

      + Add "Colour by Error".

      + Add entry for "white" in date and error keys.

      + When setting the view to a single point, don't change the scale.

      + If reloading the same file, don't change the view

      + Fix filetypes selector in open dialog.

      + Fix the charset we use for aven in certain cases.

      + Call msg_init before using msg_lang or it won't ever be set!

      + Pass wx the full language code to initialise the C library locale.

      + Fix bug in generating prefix tree view which could lead to a bogus
        leading dot on some survey names (bug probably introduced in 1.1.10).

      + "New Presentation" now ensures that the side panel is open

      + Fix updating of cached opengl lists when the view is reset to the
        default.

    * Ignore LANG if it starts with a digit to avoid problems with bogus value for
      LANG which AutoCAD installation seems to set on MS Windows.

    * (Unix version): configure: Allow SGMLTOOLS and DOCBOOK_TO_MAN to be
      specified.  Either/both can be set to ":".

    * dump3d: Report unknown (to dump3d) codes returned by img.

    * img library: Flag all stations as underground in the old "ASCII" .3d format.

    Changes in 1.1.10 (2006-07-14):

    * aven: Clicking on a survey name in the survey tree now highlights it in
      the map view.  Double-clicking zooms the view to show the clicked survey
      highlighted.  Clicking the root clears the highlighting and double-clicking
      the root restores the default view.  To expand/collapse a branch, click
      on the "[+]" or "[-]" icon to the left of the survey name.

    * aven: The measuring line can now measure to anywhere in plan or elevation
      view (not just to a station!)  In plan view the horizontal distance and
      bearing are shown, while in elevation view the vertical distance is shown.

    * aven: Moving the mouse over a station in the survey view now highlights
      that station in the survey tree (though it may not be visible if the
      survey(s) it is in aren't expanded).

    * aven: Clicking on a station to centre the view now moves the mouse pointer
      to the new location of the station (except on Mac OS X where this isn't
      allowed).

    * aven: Fix which presentation toolbar buttons are shown as depressed.

    * Fix infinite loop reading 3d files with LRUD data (bug introduced in 1.1.9).

    * vim files are now installed with the correct paths (bug introduced in 1.1.9).

    Changes in 1.1.9 (2006-07-04):

    * (Unix version): Install desktop files for aven and svxedit contributed to the
      Ubuntu package by Phil Bull, and corresponding pixmaps.

    * Fix img to filter out cross-sections which don't match the subsurvey (if
      specified).  The API now returns img_XSECT_END to mark the end of a
      passage rather than setting a flag on the last img_XSECT of the passage.

    * Enhance integration with the vim editor - this can now colour .err files, run
      cavern from vim and parse error output, and run aven from vim.  Tweak the
      existing vim mode for .svx files to fix a few minor bugs and add support for
      the new "*data passage" style.

    * aven: fix drawing of the "blob" end of the measuring line on graphics cards
      which can't draw large enough blobs for us.

    * aven: sort out confusion about what encoding everything is in which means
      that the distance measured by the measuring line actually gets displayed
      and also fixes problems with empty menu items in non-English locales in
      some cases.

    * aven: redraw grey background after a menu is closed over the aven window
      with no survey loaded.

    * aven: fix bug which caused printing to crash (introduced in 1.1.8).

    * aven: avoid crash on some machines when opening "About" dialog before having
      loaded a survey.

    * aven: Translate "Plan" and "Elevation" buttons in print view dialog.

    * (Unix version): aven: Fix character set handling of cavern output.

    * cavern: Report an error if a cross-section is specified for a station which
      doesn't exist.

    * Updated French and Italian translations.

    * (Unix version): aven: Fix "Can't open message file `en_US' using path
      `${prefix}/share/survex'" error.

    * Fix bug in 3d file reading on 64 bit platforms when used in STANDALONE mode
      (doesn't affect Survex itself, but other applications which use img.c should
      update their copy).

    * (Unix version): Add checks that wxWidgets is a non-unicode version (wx 2.6
      and later are caught by configure, whereas older wx versions are caught when
      trying to compile).

    Changes in 1.1.8 (2006.06.30):

    * Drop support for building with wxWidgets versions prior to 2.4.0
      (which was released on 2003-01-07).

    * aven: Printing through aven now uses settings from the "[aven]" section
      of print.ini, and support for hierarchical sections (using "like=")
      has been disabled.

    * aven: Change mouse actions to be compatible with those in Survex 1.0.
      The mousewheel now zooms in/out (it doesn't do anything in 1.0) and
      left drag is now smart about not rotating and zooming at the same
      time.

    * aven: Highlighting stations now happens as you type, and pressing
      "Enter" or clicking the "Find" button now pans and zooms to show the
      highlighted stations.

    * aven: Left-clicking away from a station now cancels measuring line.

    * aven: Setting view to North, South, East, or West is now animated like
      the tilt from plan to elevation.

    * aven: Fix presentation saving to also write "." for decimal points and
      presentation loading to accept either "." or ",".

    * (Unix version): aven: Add text for all toolbar items so that aven
      will work with the Gnome desktop preference for displaying toolbars as
      icons with text or just text (wxWidgets needs fixing first though).

    * (Unix version): aven: Remove the ability to detach the menu bar (yell
      if you actually used it and I'll restore it!)

    * aven: Add "all survey files" option to the "open file" dialog.

    * (MS Windows version): aven: Fix cursor keys to pan survey.

    * (MS Windows version): Built with wxWidgets 2.6.3 instead of 2.6.2.

    * (MS Windows version): Fix installer to work on Windows 2000 or XP if
      run by an unprivileged user.

    * (MS Windows version): Upgrade to the latest version of InnoSetup (the
      installer builder we use) and include new installer translations for
      UK English, Spanish, Brazilian Portuguese, Italian, Romanian, and Slovak.

    * (MS Windows version): aven: Include Catalan and Brazilian Portuguese
      translations of messages for wxWidgets (the GUI library we use).

    * aven: Disable "Highlight exported points" if there aren't any.

    * Updates to French translation from Michel Bovey.  Also updates to German,
      Italian, Catalan, Spanish, and Romanian translations.

    * (Unix version): test suite: fix smoke test to pass even without X running
      (it was meant to but the code had a bug).

    * aven: Check if OpenGL is available and exit cleanly with a helpful error
      if it isn't.

    * (Unix version): aven: Fix --help and --version to work without a working
      X display (provided it's built with wxWidgets 2.5.1 or newer).

    * aven: Automatically select the presentation tab of the notebook when the user
      selects "New Presentation" or "Open Presentation".

    * aven: Fix "Delete" in the presentation list to not get passed on (and so not
      reset to default view as well).

    * aven: Fix Ctrl+Insert in the presentation list not to segfault if the list is
      empty.

    * aven: Fix Cursor Up and Down in the presentation list to move the highlight
      up and down instead of being passed on and moving the survey.

    * aven: Improve SVG output compatibility.  Tested with Mozilla Firefox 1.5,
      Adobe's SVG browser plugin, Gimp 2.2.8, Gqview 2.0.0, Opera 8.5,
      Safari 2.0.3, and InkScape 0.42.

    * aven: Put a 5mm border around exported SVG files to allow for station markers
      and non-zero width lines.

    * aven: Fix crash when exporting as SVG or Sketch if labels or surface data
      was turned on.

    * aven: Actually close the file we're exporting which fixes problems with it
      not always being fully written.

    Changes in 1.1.7 (2005.10.18):

    * cavern: Add validity checking for dates in *date commands (with feature
      test in testsuite).  A date entered as just "year" or "year.month" now
      becomes a date range for the relevant period (previously it became a single
      date near the middle of that period).

    * extend: Fixed 2 uninitialised flags (should fix erratic behaviour on
      with MS Windows).

    * extend: Default output name for a file called input.3d is now input_extend.3d
      rather than just extend.3d (which was annoying if you wanted to extend
      several surveys in the same directory).

    * aven: OpenGL 2.0 always includes support for point sprites so rework
      our check for them to include that knowledge.

    * aven: Regenerate depth bar if user switches to/from metric units.

    * aven: Don't clear the "there" mark just because the mouse pointer has
      moved off a station.

    * aven: When processing a .svx file, put the resultant .3d file in the
      same directory (since that's where we then try to load it from).

    * aven: Fix labelling of date colouring on 32 bit platforms.

    * aven: If "colour by date" is on and we load a survey with no date info
      (or all surveyed on the same date) then set "colour by none".

    * aven: Make the error dialog modal and remove a signal handler once it
      has fired to prevent endless (or seemingly endless) cascades of error
      dialogs.

    * aven: Enforce a minimum object volume diameter of 1m to avoid problems
      if a survey file with only one station in is loaded.

    * aven: Fix problems with indicators disappearing when we're drawing
      blobs and/or crosses the slow (but always supported) way.  (Problem
      introduced in 1.1.6).

    * (Unix version): aven: Really stop setting extra toolbar margin when using
      GTK2.0.  The attempt to fix this in 1.1.3 failed because __WXGTK12__ is
      set for GTK+ 1.2 or *any later release* so is true for GTK+ 2.0 too!

    * (Unix version): aven: Add details of which of wxGTK, wxMotif, and wxX11
      we've been compiled with, and which GTK+/Motif version where appropriate.

    * (Unix version): Fixed build on Fedora Core 3.

    * documentation: Updates to 3d file format specification from Mike McCombe.

    Changes in 1.1.6 (2005.10.10):

    * (MS Windows version): Distribution is about a third smaller than 1.1.5
      (mostly because mingwm10.dll is no longer required).

    * aven: If aven is asked to load a .svx, .dat, or .mak file, run cavern on
      it, showing cavern's output in a window (with errors and warnings clickable
      to load the offending file into an editor), and then loading the resulting
      3d file.

    * aven: Added "Colour by Date" option.

    * aven: Disable "Colour by Depth" option if there's no elevation variation.

    * aven: Don't crash if trying to load a survey with no elevation variation.
      Instead turn off depth colouring.

    * aven: Export as HPGL added.

    * aven: Improved update of mouse coordinates and measuring line (thanks to
      Martin Green).

    * aven: Show the coordinates of either the mouse pointer or the nearest
      survey station to it (if there is one near enough).  Showing both was
      confusing and meant the status bar overflowed on smaller displays.

    * aven: When printing an extended elevation, don't show bearing and elevation.

    * aven: Don't lock "flat" surveys which aren't extended elevations - a
      flat survey with LRUD data isn't flat any more!

    * aven: When we have to draw blobs and crosses the slow way (because the
      graphics hardware doesn't support the fast way), draw them so that they
      should appear at the correct depth into the 3D scene instead of on top
      of everything else.

    * aven: Make "play presentation backwards" icon green to match the other
      presentation icons.

    * (MS Windows version): aven: Mouse clicks on the survey view now set the
      keyboard focus there.

    * (MS Windows version): aven: Fix first redraw of a newly loaded survey.

    * (MS Windows version): aven: Fix redrawing of measuring line.

    * cavern: Store dates for img_XSECT.

    * cavern: Fixed small one-off memory leak if you specify -o more than once.

    * (Unix version): Check environmental variable LC_MESSAGES when deciding what
      language to use for messages.

    * (MS Windows version): "Print" on a 3d file now prints through aven rather
      than the separate printer driver (Unix has done this for some time).

    * Removed old printer drivers.

    * img library: When creating a 3d file, ignore img_XSECT if we've been asked
      to write a file format version which doesn't support it.

    Changes in 1.1.5 (2005.09.20):

    * (MS Windows version): aven: Fixed crash on start-up (introduced in 1.1.4).

    * aven: Make blobs round like they are in Survex 1.0.

    * aven: If the graphics drivers don't support drawing blobs using OpenGL
      point markers, fall back to drawing filled circles.

    * aven: If the graphics drivers support it, draw crosses as texture mapped
      OpenGL point markers which is much faster.

    * aven: Cross size increased to match Survex 1.0.

    * aven: We must update which blobs are displayed if display of surface or
      underground legs is toggled.

    * cavern: Fix handling of a *solve followed by survey data, none of which is
      attached to the previous data.

    * cavern: Fixed "No survey data" error when a *solve is followed by another
      *solve (or the implicit solve at the end of processing) with no data between
      them.

    Changes in 1.1.4 (2005.09.19):

    * aven: Added Aven's icon to the "About" dialog.

    * aven: Use localised character for the decimal point (e.g. "," in most
      continental European countries).

    * aven: Previously the survey tree would get focus and then take keypresses
      (e.g. "P", "L", "Delete").  Now we pass most keypresses across so they
      operate on the cave, and transfer the input focus across when we do.

    * aven: Make pressing "Return" in the tree control expand/collapse a subtree.

    * aven: Speed up intialisation by delaying creation of OpenGL lists until
      they're needed.

    * aven: Added Mark Shinwell's bounding box with shadow of the survey.

    * aven: Disable the "Tubes" button/menu item when there's no LRUD data.

    * aven: Reworded "Restore Default Settings" as "Restore Default View".

    * (Unix version): aven: Set sensible default margins for printing and preserve
      any margin values the user specifies between runs (previously margins
      defaulted to 0 each time aven was run).

    * Documentation: Document *DATA PASSAGE in the manual.

    Changes in 1.1.3 (2005.09.07):

    * (Microsoft Windows version): Fixed build problems.

    * cavern: Allow OMIT character (-) for left/right/up/down.

    * aven: Remove an unnecessary menu separator.

    * aven: Fix "Find" and "Hide" toolbar buttons to work with GTK2.0.

    * aven: Make the tooltip for "Hide" show the number of found stations.

    * aven: If * or ? is used in a glob-style pattern, force a non-substring match.

    * aven: Enable "New Presentation" when there's a 3d file loaded, rather than
      when there's a presentation loaded.

    * aven: Make entrances green in side panel tree list to match green blobs used
      in cave view.

    * aven: Don't show surface labels if we're not showing surface data, etc.

    * aven: Merge "Start Rotation" and "Stop Rotation" into "Toggle Rotation" and
      make "Space" the key for this.  Keep Return working "Stop Rotation" so
      existing users are happy, but don't advertise it.

    * aven: Normalise filename by adding any extension used, and use the normalised
      filename for file history and window title.

    * (Unix version): aven: Stop setting extra toolbar margin when using GTK2.0
      as the toolbar buttons already have a sensible margin - the extra margin is
      only needed with GTK1.2.

    * aven: Fix handling of plumb legs in tube model.

    * aven: Fixed swapped L and R in tube model.

    * extend: Preserve UD cross-section information in extended elevation.

    * extend: Add new messages for John Pybus' enhancements.

    Changes in 1.1.2 (never formally released):

    * Added support for LRUD data in .svx files, in .3d files, and aven can
      now load and display it on screen and on printouts.  The ability to "fake"
      LRUD data in aven is gone for now but will reappear in some form later.

    * cavern: Removed support for writing Chasm's 3dx format.  We're going to
      fold any desirable missing chasm functionality into aven.

    * aven: Rearranged mouse actions as discussed on the mailing list.  Added
      cursors for each different mouse action to help the user learn what each
      does.  Also added cursors for the "compass" and "clino" as well as the
      scalebar to suggest to the user that they can be dragged to change the view.

    * (Unix version): aven: Don't segfault if LANG isn't a known language.

    * tests/smoketest.tst: If X windows is running, check that we can run aven
      with --help and --version.

    * tests/cavern.tst: Fixed cavern.tst to warn if it is skipping a test because
      no results are listed for it.  This revealed that there was a "newline" test
      which should have been called "badnewline", and was a broken testcase too!
      Fixed all these problems.

    * cavern: Applied Simeon Warner's patch for handling backcompass, backclino,
      and omitted forward compass/clino readings in Compass DAT files.  Added
      a feature test for this to the testsuite.

    * It no longer makes sense to have an option not to build aven or to build aven
      without OpenGL so remove old machinery for this from configure and the
      sources.

    * (Unix version): configure: Check if "-lXxf86vm" is needed.

    * configure: Better output for strcasecmp test.

    * aven: Fix crosses to work much better.  Not a total fix - their position
      in the Z buffer isn't correct and they're rather slow to plot.

    * aven: Don't regenerate the hittest grid every time the mouse moves while
      animating, which solves the mysterious pausing effect (thanks go to Martin
      Green for spotting this!)  Also clear all the status bar coordinates when
      animating.

    * aven: Sort out clashing menu shortcuts in some languages.

    * aven: Fixed compilation problem on x86_64

    * SPUD: Pruned out stuff which has been done or which is not actually relevant
      to this branch.

    * Merge various changes from 1.0 branch:

      + aven: Port over "printing from aven" functionality.

      + aven: Port over "export as" functionality,

      + Add David Loeffler's vim mode for .svx files.

    * aven: Fix check for whether a label is behind us in perspective view.

    * aven: Don't use an opengl list for drawing the indicators - we typically make
      a new list each time we plot them anyway.

    * Remove lingering traces of support for RISC OS and pre-386 MSDOS

    * aven: Set icon on non-Windows platforms too.  This means that with
      WindowMaker on Unix you get an icon on the AppIcon by default.

    * configure: Update wxWindows checks to handle newer wx versions.

    * Make all maintainer perl scripts "use bytes;" to avoid utf-8 double encoding
      problems.  They also all require Perl 5.8 now (hopefully this isn't an issue
      for anyone building from CVS).

    * acinclude.m4: Quote macro name for fix autotools warning.

    * Documentation: "tilt up" is "'" not ",".

    * aven: Add support for mousewheels (to tilt the cave).

    * aven: Fixed twisted transitions to and from pitches in certain cases.

    * aven: Pick a sensible initial window size when the user's desktop is spread
      over more than one monitor (works best with wx2.5 or newer, but try to do
      better with wx2.4 or earlier as well).

    * aven: Initialise GfxCore slightly later to avoid visual glitch from notebook
      contents being visible before any survey is loaded.

    * aven: Allow a coloured texture to be used

    * aven: Don't initialise until we have data (to the user, this means the window
      is default colour (grey for most systems) not black until a survey is
      loaded).

    * aven: Fixed weird "shadowed" icons.

    Changes in 1.1.1 (2004-10-06):

    * (Microsoft Windows version): aven: Hopefully fix loading a survey file at
      startup.

    * aven: Delay loading the bitmap for the "About" dialog until it is first
      needed.  We want start up to be as quick as possible.

    Changes between 1.0.32 and 1.1.0 (never formally released):

    * NOTE: Survex 1.1.X releases are development snapshots made available for
      the purposes of allowing wider testing and getting more user feedback.  Once
      the code has stabilised the version number will be raised to 1.2.0.

    * aven: Now uses OpenGL for 3d rendering - you may need to install drivers if
      you're using Windows 95 - these can be obtained from:
      http://download.microsoft.com/download/win95upg/info/1/W95/EN-US/Opengl95.exe

    * aven: Solid passages - passage dimensions are currently inferred from
      the leg length (pretty effective as you can measure longer legs in
      larger passages).  Use of real LRUD data coming soon...

    * aven: Depth colouring is now continuously varying.

    * aven: Colour by depth can now be turned off (and there's the start of a
      framework for properly implementing colour by date, error, etc).

    * aven: Find stations moved onto the toolbar and now uses a simple wildcarded
      match (? matches any character, * matches any number of characters).

    * aven: We now use the status bar for coordinates, distances, etc to make
      better use of screen space.

    * aven: Full screen mode (F11).

    * aven: Perspective view.

    * aven: Context sensitive cursor shape - needs more work.

    * aven: Mouse actions changed (hopefully they're now more natural, but
      you may find the change disorientating - feedback wanted on this).

    * aven: Added "presentations" which allow you to set up fly-through paths
      and load/save/run them.

    * aven: A presentation can be exported as a movie file.

    * aven: Added Save screenshot facility.

    * aven: Depth fogging option.

    * aven: Added Smooth Lines option.

    * aven: Added Textured Walls option.

    * aven: If a survey has surface legs but no underground legs, default to
      showing the surface legs.

    * cavern: Dates given to *date are now stored in the 3d file.